import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.*;
import java.net.Socket;
import java.util.*;
import java.util.List;
import java.util.Timer;
import javax.swing.*;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
import javax.swing.text.BadLocationException;
import javax.swing.text.DefaultCaret;


public class Administrator {

    //User authentication components

    static String myUserName; //TODO: How to save userName and password for different thread?
    static String password;
    static JList<String> chatList;
    static String chatNumber;

    static JFrame frame = new JFrame("Administrator Login");
    static JPanel panel = new JPanel();

    static JLabel usernameLabel = new JLabel("Username");
    static JLabel passwordLabel = new JLabel("Password");

    static JTextField usernameField = new JTextField(20);
    static JPasswordField passwordField = new JPasswordField(20);
    static JPasswordField passwordField2 = new JPasswordField();

    static JButton loginButton = new JButton("Login");

    //Menu components
    static JLabel welcomeLabel = new JLabel();

    static JButton messageButton = new JButton("View All Chats");
    static JButton settingsButton = new JButton("Settings");
    static JButton editProfileButton = new JButton("Edit Profile");
    static JButton banButton = new JButton("Ban User");

    //Edit user page
    static JLabel currentPasswordLabel = new JLabel("New Password");
    static JLabel newPasswordLabel = new JLabel("New Password");

    static JPasswordField currentPasswordField = new JPasswordField(20);
    static JPasswordField newPasswordField = new JPasswordField(20);

    static JButton changePassword = new JButton("Confirm");
    static JButton backButton = new JButton("Back");

    //Settings Page
    static JLabel backGroundColorLabel = new JLabel("Background Color RGB");
    static JLabel messageColorLabel = new JLabel("Message Color RGB");


    static JTextField backFieldR = new JTextField(3);
    static JTextField backFieldG = new JTextField(3);
    static JTextField backFieldB = new JTextField(3);

    static String backR = "255";
    static String backG = "255";
    static String backB = "255";

    static JTextField textFieldR = new JTextField(3);
    static JTextField textFieldG = new JTextField(3);
    static JTextField textFieldB = new JTextField(3);

    static String textR = "0";
    static String textG = "0";
    static String textB = "0";

    static JButton setColor1 = new JButton("Set");
    static JButton setColor2 = new JButton("Set");

    static JTextField backgroundColorPreview = new JTextField();
    static JTextField messageColorPreview = new JTextField();

    static Color baseColor = new Color(255, 255, 255);
    static Color textColor = new Color(0, 0, 0);

    //Chat List
    static JFrame frameList = new JFrame("Chat List");
    static JPanel panelList = new JPanel();

    //Chat List Button
    static JButton backButtonList = new JButton("Back");

    //Chat Frame Buttons
    static JFrame frameChat = new JFrame("Chat");                  // Chat JFrame
    static JButton backButtonChat = new JButton("Back");                     // back to contacts
    static JButton sendButtonChat = new JButton("Send");                     // send message
    static JButton editButtonChat = new JButton("Edit Message");                     // edit message
    static JButton deleteButtonChat = new JButton("Delete Message");                   // delete message
    static JButton exportChatButton = new JButton("Export Chat");
    static JButton membersButton = new JButton("Members");
    static JButton showTimeButton = new JButton("Show/Hide Time");
    static JTextField textFieldChat = new JTextField();                   // write text
    static JTextArea textAreaChat = new JTextArea();                     // show chat
    static boolean showTime = false;

    //Socket
    static Socket socket;
    static Scanner in;
    static PrintWriter out;
    static Timer timer = new Timer();
    static TimerTask timerTask = new TimerTask() {
        public void run() {
        }
    };


    public Administrator() throws IOException {

    }

    //Menu GUI
    public static void createMenuGUI() throws IOException {

        panel.removeAll();
        panel.repaint();


        frame.setTitle("Administrator");

        welcomeLabel.setText("Administrator");
        welcomeLabel.setFont(new Font("", Font.BOLD, 20));
        welcomeLabel.setBounds(180,60,1000,25);
        panel.add(welcomeLabel);

        panel.add(messageButton);
        messageButton.setBounds(150,130,200,50);

        panel.add(settingsButton);
        settingsButton.setBounds(150,180,200,50);

        panel.add(editProfileButton);
        editProfileButton.setBounds(150,230,200,50);

        panel.add(banButton);
        banButton.setBounds(150,280,200,50);

        frame.pack();
        frame.setSize(500,400);
        frame.setResizable(false);
        frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        panel.setVisible(true);
        frame.setVisible(true);
    }

    //Change settings
    public static void settingsGUI() throws IOException {

        panel.removeAll();
        panel.repaint();

        frame.setTitle("Messenger-Settings");


        panel.add(backButton);
        backButton.setBounds(20,20,70,25);

        welcomeLabel.setText("Change Visuals");
        welcomeLabel.setFont(new Font("", Font.BOLD, 25));
        welcomeLabel.setBounds(150,90,1000,35);
        panel.add(welcomeLabel);

        panel.add(backgroundColorPreview);
        backgroundColorPreview.setBackground(baseColor);
        backgroundColorPreview.setBounds(60,140,25,25);
        backgroundColorPreview.setEditable(false);

        backGroundColorLabel.setBounds(90,140,165,25);
        panel.add(backGroundColorLabel);

        backFieldR.setBounds(250, 140, 40, 25);
        backFieldG.setBounds(290, 140, 40, 25);
        backFieldB.setBounds(330, 140, 40, 25);
        backFieldR.setText(backR);
        backFieldG.setText(backG);
        backFieldB.setText(backB);

        panel.add(backFieldR);
        panel.add(backFieldG);
        panel.add(backFieldB);

        panel.add(setColor1);
        setColor1.setBounds(380,140,70,25);

        panel.add(messageColorPreview);
        messageColorPreview.setBackground(textColor);
        messageColorPreview.setBounds(60,170,25,25);
        messageColorPreview.setEditable(false);


        messageColorLabel.setBounds(90,170,165,25);
        panel.add(messageColorLabel);

        textFieldR.setBounds(250, 170, 40, 25);
        textFieldG.setBounds(290, 170, 40, 25);
        textFieldB.setBounds(330, 170, 40, 25);
        textFieldR.setText(textR);
        textFieldG.setText(textG);
        textFieldB.setText(textB);

        panel.add(textFieldR);
        panel.add(textFieldG);
        panel.add(textFieldB);

        panel.add(setColor2);
        setColor2.setBounds(380,170,70,25);


        frame.pack();
        frame.setSize(500,400);
        frame.setResizable(false);
        frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        panel.setVisible(true);
        frame.setVisible(true);

    }


    //Change Password GUI
    public static void changePasswordGUI() throws IOException {

        panel.removeAll();
        panel.repaint();

        frame.setTitle("Messenger-Settings");

        panel.add(backButton);
        backButton.setBounds(20,20,70,25);

        welcomeLabel.setText("Change Password");
        welcomeLabel.setFont(new Font("", Font.BOLD, 25));
        welcomeLabel.setBounds(100,90,1000,35);
        panel.add(welcomeLabel);

        currentPasswordLabel.setBounds(80,140,165,25);
        panel.add(currentPasswordLabel);

        currentPasswordField.setBounds(200, 140,165,25);
        panel.add(currentPasswordField);

        newPasswordLabel.setBounds(80,170,165,25);
        panel.add(newPasswordLabel);

        newPasswordField.setBounds(200, 170,165,25);
        panel.add(newPasswordField);

        panel.add(changePassword);
        changePassword.setBounds(210,230,120,25);

        frame.pack();
        frame.setSize(500,400);
        frame.setResizable(false);
        frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        panel.setVisible(true);
        frame.setVisible(true);

    }

    //Login GUI
    public static void createLoginGUI() throws IOException {

        frame.add(panel);
        panel.setLayout(null);

        usernameLabel.setBounds(110,30,80,25);
        panel.add(usernameLabel);
        usernameField.setBounds(200,30,165,25);
        panel.add(usernameField);
        passwordLabel.setBounds(110,60,80,25);
        panel.add(passwordLabel);
        passwordField.setBounds(200, 60,165,25);
        panel.add(passwordField);

        panel.add(loginButton);
        loginButton.setBounds(210,100,80,25);

        frame.pack();
        frame.setSize(500,200);
        frame.setResizable(false);
        frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        panel.setVisible(true);
        frame.setVisible(true);

    }


    public static void createChatListGui(Socket socket) throws IOException {
        frameList = new JFrame("Chat List - " + myUserName);
        panelList = new JPanel();
        frameList.add(panelList);
        panelList.setLayout(null);

        Container content = frameList.getContentPane();
        content.setLayout(new BorderLayout());
        content.add(cTopPanel(), BorderLayout.NORTH);

        content.add(cMidPanel(socket), BorderLayout.CENTER);

        frameList.pack();
        frameList.setSize(600,400);
        frameList.setResizable(false);
        frameList.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        panelList.setVisible(true);
        frameList.setVisible(true);
    }

    public static JPanel cTopPanel() {
        JPanel topPanel = new JPanel();

        topPanel.add(backButtonList);

        return topPanel;
    }

    public static JList<String> cMidPanel(Socket socket) throws IOException {
        DefaultListModel<String> listModel = new DefaultListModel<>();
        in = new Scanner(socket.getInputStream());
        out = new PrintWriter(socket.getOutputStream(), true);
        out.println("Administrator");
        out.flush();

        int size = Integer.parseInt(in.nextLine());

        for (int i = 0; i < size; i++) {
            String chats = in.nextLine();
            listModel.addElement(chats);
        }

        //create the list
        chatList = new JList<>(listModel);
        chatList.setBackground(baseColor);
        DefaultListCellRenderer renderer = (DefaultListCellRenderer) chatList.getCellRenderer();
        renderer.setHorizontalAlignment(SwingConstants.CENTER);
        chatList.setFont(new Font(chatList.getName(), Font.PLAIN, 20));
        chatList.addListSelectionListener(new ListSelectionListener() {
            @Override
            public void valueChanged(ListSelectionEvent e) {

                if (!e.getValueIsAdjusting()) {
                    String select = chatList.getSelectedValue();
                    chatNumber = select.split(":")[0];
                    String groupName = select.split(":")[1];
                    groupName = groupName.replaceAll(" ", "");
                    frameList.dispose();

                    try {
                        createChatGUI(chatNumber, socket, groupName);
                    } catch (IOException ioException) {
                        ioException.printStackTrace();
                    }
                    startUpdateTimer(chatNumber, socket);
                }

            }
        });

        frameList.add(new JScrollPane(chatList));

        return chatList;
    }

    public static void createChatGUI(String chatNumber, Socket socket, String groupName) throws IOException {
        frameChat = new JFrame();

        if (groupName.contains(",")) {
            groupName = groupName.replace("," , "");
            groupName = groupName.replace(myUserName, "");
        }

        frameChat.setLayout(new BorderLayout());

        // chat name
        JLabel chatName = new JLabel(groupName);
        chatName.setFont(new Font(chatName.getName(), Font.PLAIN, 15));

        // Sub Panel
        JPanel north = new JPanel(new GridLayout(1, 4));            // north panel
        north.add(backButtonChat);
        north.add(new JPanel());
        north.add(chatName);
        north.add(new JPanel());

        JPanel south = new JPanel(new BorderLayout());
        south.add(textFieldChat, BorderLayout.CENTER);
        south.add(sendButtonChat, BorderLayout.EAST);

        JPanel center = new JPanel(new GridLayout(1, 1));
        center.add(new JScrollPane(textAreaChat));
        textAreaChat.setEditable(false);
        textAreaChat.setBackground(baseColor);
        textAreaChat.setForeground(textColor);
        DefaultCaret caret = (DefaultCaret)textAreaChat.getCaret();
        caret.setUpdatePolicy(DefaultCaret.ALWAYS_UPDATE);

        JPanel east = new JPanel(new GridLayout(6, 1));
        east.add(showTimeButton);
        east.add(editButtonChat);
        east.add(deleteButtonChat);
        east.add(exportChatButton);
        east.add(membersButton);

        // Add to Main Panel
        frameChat.add(north, BorderLayout.NORTH);
        frameChat.add(south, BorderLayout.SOUTH);
        frameChat.add(center, BorderLayout.CENTER);
        frameChat.add(east, BorderLayout.EAST);

        frameChat.setSize(600, 400);
        frameChat.setLocationRelativeTo(null);
        frameChat.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        frameChat.setVisible(true);

        getHistory(chatNumber, socket);
    }





    public static void listening(Socket socket) throws IOException {

        Scanner in = new Scanner(socket.getInputStream());
        PrintWriter out = new PrintWriter(socket.getOutputStream(), true);

        loginButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {

                new Thread(new Runnable() {
                    public void run() {

                        out.println("USERNAME_PASSWORD_LOGIN"+ "," + usernameField.getText() + "," + String.valueOf(passwordField.getPassword()));

                        if(in.nextLine().contains("TRUE")){

                            myUserName = usernameField.getText();
                            password = String.valueOf(passwordField.getPassword());

                            if (!myUserName.equals("Admin")) {
                                JOptionPane.showMessageDialog(null, "You are not Administrator!",
                                        "For Administrator Only", JOptionPane.WARNING_MESSAGE);
                                return;
                            }

                            //frame.setVisible(false);

                            //System.exit(0); //TODO: Can we use this?
                            try {
                                createMenuGUI();
                            } catch (IOException ioException) {
                                ioException.printStackTrace();
                            }
                        }

                        else{
                            passwordField.setText("");
                            JOptionPane.showMessageDialog(null, "Incorrect username or password", "Login", JOptionPane.ERROR_MESSAGE);

                        }

                    }
                }).start();
            }
        });


        //Edit profile
        editProfileButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {

                new Thread(new Runnable() {
                    public void run() {
                        try {
                            changePasswordGUI();
                        } catch (IOException ioException) {
                            ioException.printStackTrace();
                        }
                    }
                }).start();
            }
        });

        //Settings
        settingsButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {

                new Thread(new Runnable() {
                    public void run() {
                        try {
                            settingsGUI();
                        } catch (IOException ioException) {
                            ioException.printStackTrace();
                        }
                    }
                }).start();
            }
        });

        //Change background color
        setColor1.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                int r;
                int g;
                int b;
                try {
                    r = Integer.parseInt(backFieldR.getText());
                    g = Integer.parseInt(backFieldG.getText());
                    b = Integer.parseInt(backFieldB.getText());
                } catch (NumberFormatException ne) {
                    JOptionPane.showMessageDialog(null, "Invalid Color", "Change Color",
                            JOptionPane.ERROR_MESSAGE);
                    return;
                }
                if (r < 0 || r > 255 || g < 0 || g > 255 || b < 0 || b > 255) {
                    JOptionPane.showMessageDialog(null, "Invalid Color", "Change Color",
                            JOptionPane.ERROR_MESSAGE);
                    return;
                }
                baseColor = new Color(r, g, b);
                backR = String.valueOf(r);
                backG = String.valueOf(g);
                backB = String.valueOf(b);
                backgroundColorPreview.setBackground(baseColor);
                frame.repaint();
            }
        });

        //Change message color
        setColor2.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                int r;
                int g;
                int b;
                try {
                    r = Integer.parseInt(textFieldR.getText());
                    g = Integer.parseInt(textFieldG.getText());
                    b = Integer.parseInt(textFieldB.getText());
                } catch (NumberFormatException ne) {
                    JOptionPane.showMessageDialog(null, "Invalid Color", "Change Color",
                            JOptionPane.ERROR_MESSAGE);
                    return;
                }
                if (r < 0 || r > 255 || g < 0 || g > 255 || b < 0 || b > 255) {
                    JOptionPane.showMessageDialog(null, "Invalid Color", "Change Color",
                            JOptionPane.ERROR_MESSAGE);
                    return;
                }
                textColor = new Color(r, g, b);
                textR = String.valueOf(r);
                textG = String.valueOf(g);
                textB = String.valueOf(b);
                messageColorPreview.setBackground(textColor);
                frame.repaint();
            }
        });

        //Reset password
        changePassword.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {

                new Thread(new Runnable() {
                    public void run() {

                        String password1;
                        String password2;

                        password1 = String.valueOf(currentPasswordField.getPassword());
                        password2 = String.valueOf(newPasswordField.getPassword());


                        if(!password1.matches(password2)){
                            JOptionPane.showMessageDialog(null, "Passwords do not match!", "Password Change", JOptionPane.ERROR_MESSAGE);
                            passwordField.setText("");
                            passwordField2.setText("");
                        }

                        if(password1.matches(password2)){
                            out.println("PASSWORD_CHANGE" + "," + myUserName + "," + password1);
                        }

                        if((in.nextLine()).contains("PASSWORD_CHANGE_TRUE")){
                            JOptionPane.showMessageDialog(null, "Password Changed!", "Password Change", JOptionPane.INFORMATION_MESSAGE);
                            panel.removeAll();
                            panel.repaint();
                            try {
                                createMenuGUI();
                            } catch (IOException ioException) {
                                ioException.printStackTrace();
                            }
                        }
                        else{
                            JOptionPane.showMessageDialog(null, "Password Change Failed! Try again.", "Password Change", JOptionPane.ERROR_MESSAGE);
                        }

                    }
                }).start();
            }
        });

        //Back Button to Menu
        backButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {

                new Thread(new Runnable() {
                    public void run() {
                        panel.removeAll();
                        panel.repaint();
                        try {
                            createMenuGUI();
                        } catch (IOException ioException) {
                            ioException.printStackTrace();
                        }
                    }
                }).start();
            }
        });

        messageButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {

                new Thread(new Runnable() {
                    public void run() {
                        frame.setVisible(false);
                        frame.dispose();
                        out.println("MESSAGE");
                        try {
                            createChatListGui(socket);
                        } catch (IOException ioException) {
                            ioException.printStackTrace();
                        }

                    }
                }).start();
            }
        });

        backButtonList.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                frameList.setVisible(false);
                panelList.setVisible(false);
                frameList.dispose();
                try {
                    createMenuGUI();
                } catch (IOException ioException) {
                    ioException.printStackTrace();
                }
            }
        });

        sendButtonChat.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                cancelTimer();
                if (textFieldChat.getText().equals("")) {
                    return;
                }
                try {
                    Thread.sleep(100);
                    send(chatNumber, socket);
                } catch (IOException | InterruptedException ioException) {
                    ioException.printStackTrace();
                }
                textFieldChat.setText("");
                startUpdateTimer(chatNumber, socket);
            }
        });

        editButtonChat.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                cancelTimer();
                try {
                    Thread.sleep(100);
                    edit(chatNumber, socket);
                    update(chatNumber, socket);
                } catch (IOException | BadLocationException | InterruptedException ioException) {
                    ioException.printStackTrace();
                }
                startUpdateTimer(chatNumber, socket);
            }
        });

        deleteButtonChat.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                cancelTimer();
                try {
                    Thread.sleep(100);
                    delete(chatNumber, socket);
                    update(chatNumber, socket);
                } catch (IOException | BadLocationException | InterruptedException ioException) {
                    ioException.printStackTrace();
                }
                startUpdateTimer(chatNumber, socket);
            }
        });

        exportChatButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                cancelTimer();
                try {
                    Thread.sleep(100);
                    exportCSV(chatNumber, socket);
                } catch (InterruptedException | IOException ioException) {
                    ioException.printStackTrace();
                }
                startUpdateTimer(chatNumber, socket);
            }
        });

        membersButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                cancelTimer();
                try {
                    Thread.sleep(100);
                    viewMember(chatNumber, socket);
                } catch (InterruptedException | IOException ioException) {
                    ioException.printStackTrace();
                }
                startUpdateTimer(chatNumber, socket);
            }
        });

        showTimeButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                cancelTimer();
                try {
                    Thread.sleep(100);
                    if (showTime) {
                        showTime = false;
                    } else {
                        showTime = true;
                    }

                } catch (InterruptedException ioException) {
                    ioException.printStackTrace();
                }
                startUpdateTimer(chatNumber, socket);
            }
        });

        backButtonChat.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                cancelTimer();
                try {
                    Thread.sleep(100);
                    frameChat.setVisible(false);
                    frameChat.dispose();
                    frameList.setVisible(true);
                    panelList.setVisible(true);
                    chatNumber = "";

                }catch (InterruptedException ioException) {
                    ioException.printStackTrace();
                }
            }
        });

        banButton.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                try {
                    banUser(socket);
                }catch (IOException ioException) {
                    ioException.printStackTrace();
                }
            }
        });



    }

    public static void banUser(Socket socket) throws IOException {
        BufferedReader reader = new BufferedReader(new InputStreamReader(socket.getInputStream()));
        PrintWriter writer = new PrintWriter(socket.getOutputStream());
        writer.write("BanUser");
        writer.println();
        writer.flush();
        int num = Integer.parseInt(reader.readLine());
        String[] allusers = new String[num];
        for (int i = 0; i < num; i++) {
            allusers[i] = reader.readLine();
        }

        String select = (String) JOptionPane.showInputDialog(null, "Select user to ban",
                "Ban User", JOptionPane.QUESTION_MESSAGE, null, allusers, allusers[0]);                   // message selected
        if (select == null) {
            writer.write("");
            writer.println();
            writer.flush();
            return;
        }

        int yesno = JOptionPane.showConfirmDialog(null, "Ban: " + select, "Ban User",
                JOptionPane.YES_NO_OPTION);

        if (yesno == JOptionPane.NO_OPTION) {
            writer.write("");
            writer.println();
            writer.flush();
            return;
        }

        writer.write(select);
        writer.println();
        writer.flush();

        JOptionPane.showMessageDialog(null, select + " is banned!", "Ban User", JOptionPane.INFORMATION_MESSAGE);
    }

    // All chat methods

    public static void send(String chatNumber, Socket socket) throws IOException {
        PrintWriter writer = new PrintWriter(socket.getOutputStream());
        writer.write("SendMessage" + "," + chatNumber + "," + myUserName + "," + textFieldChat.getText());
        writer.println();
        writer.flush();
    }

    public static void getHistory(String chatNumber, Socket socket) throws IOException {
        BufferedReader reader = new BufferedReader(new InputStreamReader(socket.getInputStream()));
        PrintWriter writer = new PrintWriter(socket.getOutputStream());
        writer.write("GetMessage" + "," + chatNumber + "," + myUserName);
        writer.println();
        writer.flush();
        textAreaChat.setText("");
        String line = reader.readLine();                // first line (count)
        if (!line.equals("null")) {
            int count = Integer.parseInt(line);        // number of history
            for (int i = 0; i < count; i++) {
                line = reader.readLine();
                if (showTime) {
                    textAreaChat.append(line + "\n");
                } else {
                    textAreaChat.append(line.substring(line.indexOf("  ") + 1) + "\n");
                }
            }
        }
    }

    public static void update(String chatNumber, Socket socket) throws IOException, BadLocationException {
        BufferedReader reader = new BufferedReader(new InputStreamReader(socket.getInputStream()));
        PrintWriter writer = new PrintWriter(socket.getOutputStream());
        writer.write("GetMessage" + "," + chatNumber + "," + myUserName);
        writer.println();
        writer.flush();
        String line = reader.readLine();                // first line (count)
        int start;                                      // start of line
        int end;                                        // end of line
        if (line == null) {
            return;
        }
        if (!line.equals("null")) {
            int count = Integer.parseInt(line);        // number of history
            if (textAreaChat.getLineCount() != count + 1) {
                textAreaChat.setText("");
                for (int j = 0; j < count; j++) {
                    line = reader.readLine();
                    if (showTime) {
                        textAreaChat.append(line + "\n");
                    } else {
                        textAreaChat.append(line.substring(line.indexOf("  " ) + 1) + "\n");
                    }
                }
                return;
            }
            for (int i = 0; i < textAreaChat.getLineCount() - 1; i++) {
                start = textAreaChat.getLineStartOffset(i);
                end = textAreaChat.getLineEndOffset(i);
                line = reader.readLine();
                if (showTime) {
                    if (!textAreaChat.getText(start, end - start - 1).equals(line)) {
                        textAreaChat.replaceRange(line + "\n", start, end);
                    }
                } else {
                    if (!textAreaChat.getText(start, end - start - 1).equals(line.substring(line.indexOf("  " ) + 1))) {
                        textAreaChat.replaceRange(line.substring(line.indexOf("  ") + 1) + "\n", start, end);
                    }
                }

            }

        }
    }

    public static void edit(String chatNumber, Socket socket) throws IOException, BadLocationException {
        BufferedReader reader = new BufferedReader(new InputStreamReader(socket.getInputStream()));
        PrintWriter writer = new PrintWriter(socket.getOutputStream());
        if (textAreaChat.getText().equals("")) {
            JOptionPane.showMessageDialog(null, "No history", "Edit Message",
                    JOptionPane.ERROR_MESSAGE);
            return;
        }
        writer.write("EditMessage" + "," + chatNumber + "," + myUserName);
        writer.println();
        writer.flush();
        String fistline = reader.readLine();                    // first line
        int count = Integer.parseInt(fistline);        // number of history
        // re-format message to show
        String[] myMessages = new String[count];                        //  my messages
        String[] messagesToShow = new String[count];                        // list of my messages
        for (int i = 0; i < count; i++) {
            myMessages[i] = reader.readLine();
            messagesToShow[i] = myMessages[i].substring(0, myMessages[i].indexOf(" ") + 9) + "  "
                    + myMessages[i].substring(myMessages[i].indexOf(",") + myUserName.length() + 2);
        }

        // Select
        Collections.reverse(Arrays.asList(messagesToShow));

        String messageSelected = (String) JOptionPane.showInputDialog(null, "Select message to edit",
                "Edit Message", JOptionPane.QUESTION_MESSAGE, null, messagesToShow,
                messagesToShow[0]);                   // message selected
        if (messageSelected == null) {
            writer.write("");
            writer.println();
            writer.flush();
            return;
        }

        int index = myMessages.length - 1 - Arrays.asList(messagesToShow).indexOf(messageSelected);  // index of message
        String newText = "";                                                        // new text entered
        // edit
        do {
            newText = JOptionPane.showInputDialog(null,
                    "Edit: " + messageSelected.substring(messageSelected.indexOf(" ") + 11), "Edit Message",
                    JOptionPane.QUESTION_MESSAGE);                  // after edit
            if (newText == null) {
                writer.write("");
                writer.println();
                writer.flush();
                return;
            }
            if (newText.equals("")) {
                JOptionPane.showMessageDialog(null, "Please enter something or choose Delete", "Edit Message",
                        JOptionPane.ERROR_MESSAGE);
            }
        } while (newText.equals(""));

        String originalMessage = myMessages[index];
        writer.write(originalMessage);
        writer.println();
        writer.flush();
        writer.write(newText + " [edited]");
        writer.println();
        writer.flush();

    }

    public static void delete(String chatNumber, Socket socket) throws IOException, BadLocationException {
        BufferedReader reader = new BufferedReader(new InputStreamReader(socket.getInputStream()));
        PrintWriter writer = new PrintWriter(socket.getOutputStream());
        if (textAreaChat.equals("")) {
            JOptionPane.showMessageDialog(null, "No history", "Edit Message",
                    JOptionPane.ERROR_MESSAGE);
            return;
        }
        writer.write("DeleteMessage" + "," + chatNumber + "," + myUserName);
        writer.println();
        writer.flush();

        String fistline = reader.readLine();                    // first line

        int count = Integer.parseInt(fistline);        // number of history
        // re-format message to show
        String[] myMessages = new String[count];                        //  my messages
        String[] messagesToShow = new String[count];                        // list of my messages
        for (int i = 0; i < count; i++) {
            myMessages[i] = reader.readLine();
            messagesToShow[i] = myMessages[i].substring(0, myMessages[i].indexOf(" ") + 9) + "  "
                    + myMessages[i].substring(myMessages[i].indexOf(",") + myUserName.length() + 2);
        }

        // Select
        Collections.reverse(Arrays.asList(messagesToShow));
        String messageSelected = (String) JOptionPane.showInputDialog(null, "Select message to delete",
                "Delete Message", JOptionPane.QUESTION_MESSAGE, null, messagesToShow,
                messagesToShow[0]);                   // message selected
        if (messageSelected == null) {
            writer.write("");
            writer.println();
            writer.flush();
            return;
        }

        int index = myMessages.length - 1 - Arrays.asList(messagesToShow).indexOf(messageSelected);  // index of message

        int yesno = JOptionPane.showConfirmDialog(null, "Delete: " + messageSelected, "Delete Message",
                JOptionPane.YES_NO_OPTION);

        if (yesno == JOptionPane.NO_OPTION) {
            writer.write("");
            writer.println();
            writer.flush();
            return;
        }

        String originalMessage = myMessages[index];
        writer.write(originalMessage);
        writer.println();
        writer.flush();

    }

    public static void exportCSV(String chatNumber, Socket socket) throws IOException {

        int yesno = JOptionPane.showConfirmDialog(null, "Exporting chat history? ", "Export History",
                JOptionPane.YES_NO_OPTION);
        if (yesno == JOptionPane.NO_OPTION) {
            return;
        }

        BufferedReader reader = new BufferedReader(new InputStreamReader(socket.getInputStream()));
        PrintWriter writer = new PrintWriter(socket.getOutputStream());

        writer.write("ExportCSV" + "," + chatNumber + "," + myUserName);
        writer.println();
        writer.flush();

        int len = Integer.parseInt(reader.readLine());
        String history;
        PrintWriter pw = new PrintWriter(new File(myUserName + "_history" + chatNumber + ".csv"));
        StringBuilder builder = new StringBuilder();
        builder.append("Time,Participants,Message sender,Message\n");

        String message;
        for (int i = 0; i < len; i++) {
            history = reader.readLine();
            message = history.substring(history.indexOf("!") + 1);
            message = message.substring(message.indexOf("!") + 1);
            message = message.substring(message.indexOf("!") + 1);
            builder.append(history.split("!")[0] + ",");
            builder.append(history.split("!")[1] + ",");
            builder.append(history.split("!")[2] + ",");
            builder.append("\"" + message + "\"" + "\n");
        }
        pw.write(builder.toString());
        pw.close();

        JOptionPane.showMessageDialog(null, "Exporting history to: " + myUserName + "_history" + chatNumber + ".csv",
                "Export History", JOptionPane.INFORMATION_MESSAGE);

    }

    public static void viewMember(String chatNumber, Socket socket) throws IOException {
        BufferedReader reader = new BufferedReader(new InputStreamReader(socket.getInputStream()));
        PrintWriter writer = new PrintWriter(socket.getOutputStream());

        writer.write("ViewMember" + "," + chatNumber + "," + myUserName);
        writer.println();
        writer.flush();
        int count = Integer.parseInt(reader.readLine());
        String members = "";
        for (int i = 0; i < count; i++) {
            members = members + reader.readLine() + "\n";
        }
        JOptionPane.showMessageDialog(null, members, "Members", JOptionPane.INFORMATION_MESSAGE);

    }


    public static void cancelTimer() {
        timerTask.cancel();
        timer.cancel();

    }

    public static void startUpdateTimer(String chatNumber, Socket socket) {
        timer = new Timer();
        TimerTask timerTask = new TimerTask() {
            public void run() {
                try {
                    update(chatNumber, socket);
                } catch (IOException | BadLocationException e) {
                    e.printStackTrace();
                }
            }
        };

        timer.scheduleAtFixedRate(timerTask, 0, 1000);
    }


    public static void main(String[] args) throws IOException {

        Socket socket = new Socket("localhost", 8888);

        SwingUtilities.invokeLater(new Runnable() {
            public void run() {
                try {
                    createLoginGUI();
                    listening(socket);
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
        });
    }

}
