import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.*;
import java.net.Socket;
import java.util.*;
import java.util.List;
import java.util.Timer;
import javax.swing.*;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
import javax.swing.text.BadLocationException;
import javax.swing.text.DefaultCaret;

/**
 * Project 5
 *
 * A GUI with multiple paint functions
 *
 * @author Team 65
 * @version April 12, 2021
 */

public class Client {

    //User authentication components

    static String myUserName;
    static String password;     // password
    static JList<String> chatList;      // chatlist
    static String userName;         // user name to start chat
    static ArrayList<String> groupUserList;     // group user list
    static String chatNumber;       // chat number

    static JFrame frame = new JFrame("Login In");       // login frame
    static JPanel panel = new JPanel();         // panel

    static JLabel usernameLabel = new JLabel("Username");       // name
    static JLabel passwordLabel = new JLabel("Password");       // pass
    static JLabel passwordLabel2 = new JLabel("Password");      // pass


    static JTextField usernameField = new JTextField(20);       // name
    static JPasswordField passwordField = new JPasswordField(20);       // pass
    static JPasswordField passwordField2 = new JPasswordField();        // pass

    static JButton loginButton = new JButton("Login");      // login
    static JButton registerButton = new JButton("Register");        // regis
    static JButton createUserButton = new JButton("Create");        //create

    //Menu components
    static JLabel welcomeLabel = new JLabel();      // welcome

    static JButton messageButton = new JButton("Message");      // message
    static JButton settingsButton = new JButton("Settings");        // setting
    static JButton editProfileButton = new JButton("Edit Profile");     // edit
    static JButton deleteProfileButton = new JButton("Delete Profile");     // delete

    //Edit user page
    static JLabel currentPasswordLabel = new JLabel("New Password");        // pass
    static JLabel newPasswordLabel = new JLabel("New Password");        // pass

    static JPasswordField currentPasswordField = new JPasswordField(20);        // pass
    static JPasswordField newPasswordField = new JPasswordField(20);        // pass

    static JButton changePassword = new JButton("Confirm");        // confirm
    static JButton backButton = new JButton("Back");        // back

    //Settings Page
    static JLabel backGroundColorLabel = new JLabel("Background Color RGB");        // back
    static JLabel messageColorLabel = new JLabel("Message Color RGB");        // message

    static JTextField backFieldR = new JTextField(3);        // r
    static JTextField backFieldG = new JTextField(3);        // g
    static JTextField backFieldB = new JTextField(3);        // b

    static String backR = "255";        // r
    static String backG = "255";        // g
    static String backB = "255";        // b

    static JTextField textFieldR = new JTextField(3);        // r
    static JTextField textFieldG = new JTextField(3);        // g
    static JTextField textFieldB = new JTextField(3);        // b

    static String textR = "0";        // r
    static String textG = "0";        // g
    static String textB = "0";        // b

    static JButton setColor1 = new JButton("Set");        // set
    static JButton setColor2 = new JButton("Set");        // set

    static JTextField backgroundColorPreview = new JTextField();        // c
    static JTextField messageColorPreview = new JTextField();        // c

    static Color baseColor = new Color(255, 255, 255);        // c
    static Color textColor = new Color(0, 0, 0);        // c

    static String backgroundColor;
    static String messageColor;

    //Chat List
    static JFrame frameList = new JFrame("Chat List");        // list
    static JPanel panelList = new JPanel();        // panel

    //Chat List Button
    static JButton newChatButton = new JButton("New Chat");        // new
    static JButton newGroupButton = new JButton("New Group Chat");        // new
    static JButton backButtonList = new JButton("Back");        // back
    static JButton importButton = new JButton("Import Chat");        // import

    //Chat Frame Buttons
    static JFrame frameChat = new JFrame("Chat");                  // Chat JFrame
    static JButton backButtonChat = new JButton("Back");                     // back to contacts
    static JButton sendButtonChat = new JButton("Send");                     // send message
    static JButton editButtonChat = new JButton("Edit Message");                     // edit message
    static JButton deleteButtonChat = new JButton("Delete Message");                   // delete message
    static JButton deleteChatButton = new JButton("Delete Chat");        // delete
    static JButton exportChatButton = new JButton("Export Chat");        // export
    static JButton membersButton = new JButton("Members");        // members
    static JButton showTimeButton = new JButton("Show/Hide Time");        // time
    static JTextField textFieldChat = new JTextField();                   // write text
    static JTextArea textAreaChat = new JTextArea();                     // show chat
    static boolean showTime = false;            // time

    //Socket
    static Socket socket;        // socket
    static Scanner in;        // in
    static PrintWriter out;        // out
    static Timer timer = new Timer();        // timer
    static TimerTask timerTask = new TimerTask() {
        public void run() {
        }
    };        // timer task


    public Client() throws IOException {
    }

    //Menu GUI
    public static void createMenuGUI() throws IOException {
        panel.removeAll();
        panel.repaint();

        frame.setTitle("Messenger");

        welcomeLabel.setText("Welcome, " + myUserName + "!");
        welcomeLabel.setFont(new Font("", Font.BOLD, 20));
        welcomeLabel.setBounds(150, 60, 1000, 25);
        panel.add(welcomeLabel);

        panel.add(messageButton);
        messageButton.setBounds(150, 130, 200, 50);

        panel.add(settingsButton);
        settingsButton.setBounds(150, 180, 200, 50);

        panel.add(editProfileButton);
        editProfileButton.setBounds(150, 230, 200, 50);

        panel.add(deleteProfileButton);
        deleteProfileButton.setBounds(150, 280, 200, 50);

        frame.pack();
        frame.setSize(500, 400);
        frame.setResizable(false);
        frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        panel.setVisible(true);
        frame.setVisible(true);
    }


    public static void settingsGUI(String backgroundColor, String messageColor) throws IOException {

        panel.removeAll();
        panel.repaint();

        frame.setTitle("Messenger-Settings");


        panel.add(backButton);
        backButton.setBounds(20,20,70,25);

        welcomeLabel.setText("Change Visuals");
        welcomeLabel.setFont(new Font("", Font.BOLD, 25));
        welcomeLabel.setBounds(150,90,1000,35);
        panel.add(welcomeLabel);

        panel.add(backgroundColorPreview);
        backgroundColorPreview.setBackground(Color.decode(backgroundColor));
        backgroundColorPreview.setBounds(60,140,25,25);
        backgroundColorPreview.setEditable(false);

        backGroundColorLabel.setBounds(90,140,165,25);
        panel.add(backGroundColorLabel);

        backFieldR.setBounds(250, 140, 40, 25);
        backFieldG.setBounds(290, 140, 40, 25);
        backFieldB.setBounds(330, 140, 40, 25);

        backR =  String.valueOf(Integer.valueOf( backgroundColor.substring( 1, 3 ), 16 ));
        backG =  String.valueOf(Integer.valueOf( backgroundColor.substring( 3, 5 ), 16 ));
        backB =  String.valueOf(Integer.valueOf( backgroundColor.substring( 5, 7 ), 16 ));

        backFieldR.setText(backR);
        backFieldG.setText(backG);
        backFieldB.setText(backB);

        panel.add(backFieldR);
        panel.add(backFieldG);
        panel.add(backFieldB);

        panel.add(setColor1);
        setColor1.setBounds(380,140,70,25);


        panel.add(messageColorPreview);
        messageColorPreview.setBackground(Color.decode(messageColor));
        messageColorPreview.setBounds(60,170,25,25);
        messageColorPreview.setEditable(false);


        messageColorLabel.setBounds(90,170,165,25);
        panel.add(messageColorLabel);

        textFieldR.setBounds(250, 170, 40, 25);
        textFieldG.setBounds(290, 170, 40, 25);
        textFieldB.setBounds(330, 170, 40, 25);

        textR =  String.valueOf(Integer.valueOf( messageColor.substring( 1, 3 ), 16 ));
        textG =  String.valueOf(Integer.valueOf( messageColor.substring( 3, 5 ), 16 ));
        textB =  String.valueOf(Integer.valueOf( messageColor.substring( 5, 7 ), 16 ));

        textFieldR.setText(textR);
        textFieldG.setText(textG);
        textFieldB.setText(textB);

        panel.add(textFieldR);
        panel.add(textFieldG);
        panel.add(textFieldB);

        panel.add(setColor2);
        setColor2.setBounds(380,170,70,25);


        frame.pack();
        frame.setSize(500,400);
        frame.setResizable(false);
        frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        panel.setVisible(true);
        frame.setVisible(true);

    }

    //Change Password GUI
    public static void changePasswordGUI() throws IOException {
        panel.removeAll();
        panel.repaint();

        frame.setTitle("Messenger-Settings");

        panel.add(backButton);
        backButton.setBounds(20, 20, 70, 25);

        welcomeLabel.setText("Change Password");
        welcomeLabel.setFont(new Font("", Font.BOLD, 25));
        welcomeLabel.setBounds(100, 90, 1000, 35);
        panel.add(welcomeLabel);

        currentPasswordLabel.setBounds(80, 140, 165, 25);
        panel.add(currentPasswordLabel);

        currentPasswordField.setBounds(200, 140, 165, 25);
        panel.add(currentPasswordField);

        newPasswordLabel.setBounds(80, 170, 165, 25);
        panel.add(newPasswordLabel);

        newPasswordField.setBounds(200, 170, 165, 25);
        panel.add(newPasswordField);

        panel.add(changePassword);
        changePassword.setBounds(210, 230, 120, 25);

        frame.pack();
        frame.setSize(500, 400);
        frame.setResizable(false);
        frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        panel.setVisible(true);
        frame.setVisible(true);
    }

    //Login GUI
    public static void createLoginGUI() throws IOException {
        frame.add(panel);
        panel.setLayout(null);

        usernameLabel.setBounds(110, 30, 80, 25);
        panel.add(usernameLabel);
        usernameField.setBounds(200, 30, 165, 25);
        panel.add(usernameField);
        passwordLabel.setBounds(110, 60, 80, 25);
        panel.add(passwordLabel);
        passwordField.setBounds(200, 60, 165, 25);
        panel.add(passwordField);

        panel.add(loginButton);
        loginButton.setBounds(210, 100, 80, 25);

        panel.add(registerButton);
        registerButton.setBounds(210, 130, 80, 25);

        frame.pack();
        frame.setSize(500, 200);
        frame.setResizable(false);
        frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        panel.setVisible(true);
        frame.setVisible(true);
    }

    //Registration GUI
    public static void createregistrationGUI() throws IOException {
        panel.removeAll();
        panel.repaint();

        frame.setTitle("Registration");

        panel.remove(loginButton);

        usernameLabel.setBounds(110, 30, 80, 25);
        panel.add(usernameLabel);
        usernameField.setBounds(200, 30, 165, 25);
        panel.add(usernameField);

        passwordLabel.setBounds(110, 60, 80, 25);
        panel.add(passwordLabel);

        passwordField.setBounds(200, 60, 165, 25);
        panel.add(passwordField);

        passwordLabel2.setBounds(110, 90, 80, 25);
        panel.add(passwordLabel2);

        passwordField2.setBounds(200, 90, 165, 25);
        panel.add(passwordField2);

        panel.add(createUserButton);
        createUserButton.setBounds(210, 130, 80, 25);

        panel.repaint();
    }

    public static void createChatListGui(Socket socket) throws IOException {
        frameList = new JFrame("Chat List - " + myUserName);
        panelList = new JPanel();
        frameList.add(panelList);
        panelList.setLayout(null);

        Container content = frameList.getContentPane();
        content.setLayout(new BorderLayout());
        content.add(cTopPanel(), BorderLayout.NORTH);

        content.add(cMidPanel(socket), BorderLayout.CENTER);
        frameList.pack();
        frameList.setSize(600,400);
        frameList.setResizable(false);
        frameList.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        panelList.setVisible(true);
        frameList.setVisible(true);
    }

    public static JPanel cTopPanel() {
        JPanel topPanel = new JPanel();     // new panel

        topPanel.add(backButtonList);
        topPanel.add(newChatButton);
        topPanel.add(newGroupButton);
        topPanel.add(importButton);

        return topPanel;
    }

    public static JList<String> cMidPanel(Socket socket) throws IOException {
        DefaultListModel<String> listModel = new DefaultListModel<>();
        in = new Scanner(socket.getInputStream());
        out = new PrintWriter(socket.getOutputStream(), true);
        out.println("SortList," + myUserName);
        out.flush();

        int size = Integer.parseInt(in.nextLine());

        for (int i = 0; i < size; i++) {
            String name = in.nextLine();
            if (name.contains(",")) {
                name = name.replace(myUserName, "");
                name = name.replace(",", "");
            }
            listModel.addElement(name);
        }

        //create the list
        chatList = new JList<>(listModel);          // new list
        chatList.setBackground(Color.decode(getBackgroundColor(socket)));
        DefaultListCellRenderer renderer = (DefaultListCellRenderer) chatList.getCellRenderer();
        renderer.setHorizontalAlignment(SwingConstants.CENTER);
        chatList.setFont(new Font(chatList.getName(), Font.PLAIN, 20));
        chatList.addListSelectionListener(new ListSelectionListener() {
            @Override
            public void valueChanged(ListSelectionEvent e) {

                if (!e.getValueIsAdjusting()) {
                    out.println("START_MESSAGE");
                    out.flush();
                    String select = chatList.getSelectedValue();
                    out.println(myUserName);
                    out.flush();
                    out.println(select);
                    out.flush();
                    String index = in.nextLine();
                    String groupName = in.nextLine();

                    frameList.dispose();
                    chatNumber = index;
                    try {
                        backgroundColor = getBackgroundColor(socket);
                        messageColor = getMessageColor(socket);
//                        System.out.println(backgroundColor + " " + messageColor);
                        createChatGUI(chatNumber, socket, groupName , backgroundColor , messageColor);
                    } catch (IOException ioException) {
                        ioException.printStackTrace();
                    }
                    startUpdateTimer(chatNumber, socket);
                }

            }
        });

        frameList.add(new JScrollPane(chatList));

        return chatList;
    }


    public static void createChatGUI(String chatNumber, Socket socket, String groupName , String backgroundColor,String messageColor) throws IOException {
        frameChat = new JFrame();

        if (groupName.contains(",")) {
            groupName = groupName.replace("," , "");
            groupName = groupName.replace(myUserName, "");
        }

        frameChat.setLayout(new BorderLayout());

        // chat name
        JLabel chatName = new JLabel(groupName);
        chatName.setFont(new Font(chatName.getName(), Font.PLAIN, 15));

        // Sub Panel
        JPanel north = new JPanel(new GridLayout(1, 4));            // north panel
        north.add(backButtonChat);
        north.add(new JPanel());
        north.add(chatName);
        north.add(new JPanel());

        JPanel south = new JPanel(new BorderLayout());
        south.add(textFieldChat, BorderLayout.CENTER);
        south.add(sendButtonChat, BorderLayout.EAST);

        JPanel center = new JPanel(new GridLayout(1, 1));
        center.add(new JScrollPane(textAreaChat));
        textAreaChat.setEditable(false);
        textAreaChat.setBackground(Color.decode(backgroundColor));
        textAreaChat.setForeground(Color.decode(messageColor));
        DefaultCaret caret = (DefaultCaret)textAreaChat.getCaret();
        caret.setUpdatePolicy(DefaultCaret.ALWAYS_UPDATE);

        JPanel east = new JPanel(new GridLayout(6, 1));
        east.add(showTimeButton);
        east.add(editButtonChat);
        east.add(deleteButtonChat);
        east.add(exportChatButton);
        east.add(deleteChatButton);
        east.add(membersButton);

        // Add to Main Panel
        frameChat.add(north, BorderLayout.NORTH);
        frameChat.add(south, BorderLayout.SOUTH);
        frameChat.add(center, BorderLayout.CENTER);
        frameChat.add(east, BorderLayout.EAST);

        frameChat.setSize(600, 400);
        frameChat.setLocationRelativeTo(null);
        frameChat.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        frameChat.setVisible(true);

        getHistory(chatNumber, socket);
    }


    public static void listening(Socket socket) throws IOException {

        Scanner in = new Scanner(socket.getInputStream());                  // in
        PrintWriter out = new PrintWriter(socket.getOutputStream(), true);                  // out

        loginButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {

                new Thread(new Runnable() {
                    public void run() {

                        out.println("USERNAME_PASSWORD_LOGIN"+ "," + usernameField.getText() + "," +
                                String.valueOf(passwordField.getPassword()));

                        if(in.nextLine().contains("TRUE")){
                            myUserName = usernameField.getText();
                            password = String.valueOf(passwordField.getPassword());
                            try {
                                createMenuGUI();
                            } catch (IOException ioException) {
                                ioException.printStackTrace();
                            }
                        }

                        else{
                            passwordField.setText("");
                            JOptionPane.showMessageDialog(null, "Incorrect username or password", "Login", JOptionPane.ERROR_MESSAGE);

                        }

                    }
                }).start();
            }
        });

        // User registration
        registerButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                new Thread(new Runnable() {
                    public void run() {
                        try {
                            createregistrationGUI();
                        } catch (IOException ioException) {
                            ioException.printStackTrace();
                        }
                    }
                }).start();
            }

        });

        //Create new User
        createUserButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                new Thread(new Runnable() {
                    public void run() {

                        String username;
                        String password1;
                        String password2;
                        String special = "!@#$%&*()'+,-./:;<=>?[]^_`{|}";

                        username = usernameField.getText();
                        password1 = String.valueOf(passwordField.getPassword());
                        password2 = String.valueOf(passwordField2.getPassword());

                        if (username.equals("") || password1.equals("")) {
                            JOptionPane.showMessageDialog(null, "Please input all fields.",
                                    "Registration", JOptionPane.ERROR_MESSAGE);
                            return;
                        }

                        for (int i = 0; i < special.length(); i++) {
                            if (username.contains(String.valueOf(special.charAt(i))) || username.contains(" ") ||
                                    username.contains("DELETED")) {
                                JOptionPane.showMessageDialog(null, "Username should not include special characters.",
                                        "Registration", JOptionPane.ERROR_MESSAGE);
                                return;
                            }

                            if (password1.contains(String.valueOf(special.charAt(i))) || password1.contains(" ")) {
                                JOptionPane.showMessageDialog(null, "Password should not include special characters.",
                                        "Registration", JOptionPane.ERROR_MESSAGE);
                                return;
                            }
                        }

                        if(!password1.matches(password2)){
                            JOptionPane.showMessageDialog(null, "Passwords do not match!", "Registration", JOptionPane.ERROR_MESSAGE);
                            passwordField.setText("");
                            passwordField2.setText("");
                        }

                        if(password1.matches(password2)){
                            out.println("USERNAME_PASSWORD_REGISTER"+ "," + username + "," + password1);
                        }


                        if((in.nextLine()).contains("TRUE")){
                            JOptionPane.showMessageDialog(null, "Successfully Registered", "Registration", JOptionPane.INFORMATION_MESSAGE);

                            panel.removeAll();
                            panel.repaint();
                            try {
                                createLoginGUI();
                            } catch (IOException ioException) {
                                ioException.printStackTrace();
                            }


                        }
                        else{
                            JOptionPane.showMessageDialog(null, "Username exists", "Registration", JOptionPane.ERROR_MESSAGE);
                        }

                    }
                }).start();
            }
        });

        //Delete profile
        deleteProfileButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {

                new Thread(new Runnable() {
                    public void run() {

                        int userInput = 0;

                        userInput = JOptionPane.showConfirmDialog (null, "Permanently deleting profile! Are you sure?","WARNING",userInput);

                        if(userInput == 0){
                            out.println("DELETE_USER_PROFILE:" + myUserName);
                            JOptionPane.showMessageDialog(null, "Account Deleted", "Account Deleted", JOptionPane.INFORMATION_MESSAGE);
                            System.exit(0);

                        }


                    }
                }).start();
            }
        });

        //Edit profile
        editProfileButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {

                new Thread(new Runnable() {
                    public void run() {
                        try {
                            changePasswordGUI();
                        } catch (IOException ioException) {
                            ioException.printStackTrace();
                        }
                    }
                }).start();
            }
        });

        //Settings
        settingsButton.addActionListener(new ActionListener() {

            String backgroundHex;
            String messageHex;

            public void actionPerformed(ActionEvent e) {

                new Thread(new Runnable() {
                    public void run() {
                        try {
                            backgroundHex = getBackgroundColor(socket);
                            messageHex = getMessageColor(socket);

//                            System.out.println(backgroundHex + " " + messageHex);

                            settingsGUI(backgroundHex,messageHex);
                        } catch (IOException ioException) {
                            ioException.printStackTrace();
                        }
                    }
                }).start();
            }
        });

        //Change background color
        setColor1.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                int r;
                int g;
                int b;
                String hexInput;
                try {
                    r = Integer.parseInt(backFieldR.getText());
                    g = Integer.parseInt(backFieldG.getText());
                    b = Integer.parseInt(backFieldB.getText());

                    hexInput = String.format("#%02x%02x%02x", r, g, b);

                    out.println("SETTINGS_BACKGROUND_COLOR:" + myUserName + "," + hexInput);

                    if((in.nextLine()).contains("SETTINGS_BACKGROUND_COLOR_TRUE")){
                        JOptionPane.showMessageDialog(null, "Background color updated!", "Settings", JOptionPane.INFORMATION_MESSAGE);
                    }


                } catch (NumberFormatException ne) {
                    JOptionPane.showMessageDialog(null, "Invalid Color", "Change Color",
                            JOptionPane.ERROR_MESSAGE);
                    return;
                }
                if (r < 0 || r > 255 || g < 0 || g > 255 || b < 0 || b > 255) {
                    JOptionPane.showMessageDialog(null, "Invalid Color", "Change Color",
                            JOptionPane.ERROR_MESSAGE);
                    return;
                }
                baseColor = new Color(r, g, b);
                backR = String.valueOf(r);
                backG = String.valueOf(g);
                backB = String.valueOf(b);
                backgroundColorPreview.setBackground(baseColor);
                frame.repaint();
            }
        });

        //Change message color
        setColor2.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                int r;
                int g;
                int b;
                String hexInput;
                try {
                    r = Integer.parseInt(textFieldR.getText());
                    g = Integer.parseInt(textFieldG.getText());
                    b = Integer.parseInt(textFieldB.getText());

                    hexInput = String.format("#%02x%02x%02x", r, g, b);

                    out.println("SETTINGS_MESSAGE_COLOR:" + myUserName + "," + hexInput);

                    if((in.nextLine()).contains("SETTINGS_MESSAGE_COLOR_TRUE")){
                        JOptionPane.showMessageDialog(null, "Message color updated!", "Settings", JOptionPane.INFORMATION_MESSAGE);
                    }

                } catch (NumberFormatException ne) {
                    JOptionPane.showMessageDialog(null, "Invalid Color", "Change Color",
                            JOptionPane.ERROR_MESSAGE);
                    return;
                }
                if (r < 0 || r > 255 || g < 0 || g > 255 || b < 0 || b > 255) {
                    JOptionPane.showMessageDialog(null, "Invalid Color", "Change Color",
                            JOptionPane.ERROR_MESSAGE);
                    return;
                }
                textColor = new Color(r, g, b);
                textR = String.valueOf(r);
                textG = String.valueOf(g);
                textB = String.valueOf(b);
                messageColorPreview.setBackground(textColor);
                frame.repaint();
            }
        });

        //Reset password
        changePassword.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {

                new Thread(new Runnable() {
                    public void run() {

                        String password1;
                        String password2;

                        password1 = String.valueOf(currentPasswordField.getPassword());
                        password2 = String.valueOf(newPasswordField.getPassword());


                        if(!password1.matches(password2)){
                            JOptionPane.showMessageDialog(null, "Passwords do not match!", "Password Change", JOptionPane.ERROR_MESSAGE);
                            passwordField.setText("");
                            passwordField2.setText("");
                        }

                        if(password1.matches(password2)){
                            out.println("PASSWORD_CHANGE" + "," + myUserName + "," + password1);
                        }

                        if((in.nextLine()).contains("PASSWORD_CHANGE_TRUE")){
                            JOptionPane.showMessageDialog(null, "Password Changed!",
                                    "Password Change", JOptionPane.INFORMATION_MESSAGE);
                            panel.removeAll();
                            panel.repaint();
                            try {
                                createMenuGUI();
                            } catch (IOException ioException) {
                                ioException.printStackTrace();
                            }
                        }
                        else{
                            JOptionPane.showMessageDialog(null, "Password Change Failed! Try again.",
                                    "Password Change", JOptionPane.ERROR_MESSAGE);
                        }

                    }
                }).start();
            }
        });

        //Back Button to Menu
        backButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {

                new Thread(new Runnable() {
                    public void run() {
                        panel.removeAll();
                        panel.repaint();
                        try {
                            createMenuGUI();
                        } catch (IOException ioException) {
                            ioException.printStackTrace();
                        }
                    }
                }).start();
            }
        });

        messageButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {

                new Thread(new Runnable() {
                    public void run() {
                        frame.setVisible(false);
                        frame.dispose();
                        out.println("MESSAGE");
                        try {
                            createChatListGui(socket);
                        } catch (IOException ioException) {
                            ioException.printStackTrace();
                        }

                    }
                }).start();
            }
        });

        newChatButton.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                userName = newChat(); //Acquire the user input for the username to start chat with
                if (userName == null) {
                    return;
                }
                out.println("StartNewChat," + myUserName + "," + userName);
                //Send my username and the input username to server in a certain
                // format so the server can identify what option is needed
                String result = in.nextLine();

                if(result.equals("False")){
                    //if the user name is not valid, print a error message
                    JOptionPane.showMessageDialog(null, "UserName Invalid",
                            "Start New Chat", JOptionPane.ERROR_MESSAGE);
                } else if (result.equals("Exist")) {
                    JOptionPane.showMessageDialog(null, "The Chat Exist",
                            "Start New Chat", JOptionPane.ERROR_MESSAGE);
                } else {
                    frameList.dispose();
                    try {
                        createChatListGui(socket);
                    } catch (IOException ioException) {
                        ioException.printStackTrace();
                    }
                }
            }
        });

        newGroupButton.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                String groupName = JOptionPane.showInputDialog(null, "Enter group Name", "New Group",
                        JOptionPane.QUESTION_MESSAGE);
                if (groupName == null) {
                    return;
                }

                groupUserList = newGroupChat();

                if (groupUserList == null) {
                    return;
                }
                String userList = groupUserList.get(0);


                if (groupUserList.size() > 1){
                    for (int i = 1; i<groupUserList.size(); i++) {
                        userList = userList + "," + groupUserList.get(i);
                    }
                }

                out.println("StartNewGroup," + myUserName + "," + userList + "," + groupName);

                String A = in.nextLine();
                if(A.startsWith("False")) {
                    //if the user name is not valid, print a error message
                    String message  = "can not find user: " + A.split(",")[1];
                    JOptionPane.showMessageDialog(null, message,
                            "Start New group", JOptionPane.ERROR_MESSAGE);
                } else if (A.equals("Exist")) {
                    JOptionPane.showMessageDialog(null, "The Chat Exist",
                            "Start New Chat", JOptionPane.ERROR_MESSAGE);
                } else {
                    frameList.dispose();
                    try {
                        createChatListGui(socket);
                    } catch (IOException ioException) {
                        ioException.printStackTrace();
                    }
                }
            }
        });

        importButton.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                try {
                    frameList.dispose();
                    importChat(socket);
                    createChatListGui(socket);
                } catch (IOException ioException) {
                    ioException.printStackTrace();
                }
            }
        });

        backButtonList.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                frameList.setVisible(false);
                panelList.setVisible(false);
                frameList.dispose();
                try {
                    createMenuGUI();
                } catch (IOException ioException) {
                    ioException.printStackTrace();
                }
            }
        });

        sendButtonChat.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                cancelTimer();
                if (textFieldChat.getText().equals("")) {
                    return;
                }
                try {
                    Thread.sleep(100);
                    send(chatNumber, socket);
                } catch (IOException | InterruptedException ioException) {
                    ioException.printStackTrace();
                }
                textFieldChat.setText("");
                startUpdateTimer(chatNumber, socket);
            }
        });

        editButtonChat.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                cancelTimer();
                try {
                    Thread.sleep(100);
                    edit(chatNumber, socket);
                    update(chatNumber, socket);
                } catch (IOException | BadLocationException | InterruptedException ioException) {
                    ioException.printStackTrace();
                }
                startUpdateTimer(chatNumber, socket);
            }
        });

        deleteButtonChat.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                cancelTimer();
                try {
                    Thread.sleep(100);
                    delete(chatNumber, socket);
                    update(chatNumber, socket);
                } catch (IOException | BadLocationException | InterruptedException ioException) {
                    ioException.printStackTrace();
                }
                startUpdateTimer(chatNumber, socket);
            }
        });

        deleteChatButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                cancelTimer();
                try {
                    Thread.sleep(100);
                    boolean yesno =  deleteChat(chatNumber, socket);
                    if (yesno) {
                        frameChat.setVisible(false);
                        frameChat.dispose();
                        frameList.dispose();
                        createChatListGui(socket);
                        chatNumber = "";
                        return;
                    }
                } catch (InterruptedException | IOException ioException) {
                    ioException.printStackTrace();
                }
                startUpdateTimer(chatNumber, socket);
            }
        });

        exportChatButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                cancelTimer();
                try {
                    Thread.sleep(100);
                    exportCSV(chatNumber, socket);
                } catch (InterruptedException | IOException ioException) {
                    ioException.printStackTrace();
                }
                startUpdateTimer(chatNumber, socket);
            }
        });

        membersButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                cancelTimer();
                try {
                    Thread.sleep(100);
                    viewMember(chatNumber, socket);
                } catch (InterruptedException | IOException ioException) {
                    ioException.printStackTrace();
                }
                startUpdateTimer(chatNumber, socket);
            }
        });

        showTimeButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                cancelTimer();
                try {
                    Thread.sleep(100);
                    if (showTime) {
                        showTime = false;
                    } else {
                        showTime = true;
                    }

                } catch (InterruptedException ioException) {
                    ioException.printStackTrace();
                }
                startUpdateTimer(chatNumber, socket);
            }
        });


        backButtonChat.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                cancelTimer();
                try {
                    Thread.sleep(100);
                    frameChat.setVisible(false);
                    frameChat.dispose();
                    frameList.dispose();
                    createChatListGui(socket);
                    chatNumber = "";
                }catch (InterruptedException | IOException ioException) {
                    ioException.printStackTrace();
                }
            }
        });



    }

    public static String newChat() {
        String userName = JOptionPane.showInputDialog(null, "Please enter username of the chat you wish to start",
                "New Chat", JOptionPane.QUESTION_MESSAGE);

        return userName;
    }

    public static ArrayList newGroupChat() {
        String[] buttons = {"Add", "Finish"};
        ArrayList<String> arrayList = new ArrayList<>();
        ArrayList<String> nameList = new ArrayList<>();

        JPanel panel = new JPanel();
        panel.add(new JLabel("Add a User"));
        JTextField textField = new JTextField(10);
        panel.add(textField);
        int result = 0;

        while (result == 0) {
            result = JOptionPane.showOptionDialog(null, panel, "Start group",
                    JOptionPane.YES_NO_CANCEL_OPTION, JOptionPane.PLAIN_MESSAGE,
                    null, buttons, null);

            if (result == 0) {
                String user = textField.getText();
                if (user.equals("")) {
                    JOptionPane.showMessageDialog(null, "Invalid User",
                            "Start group", JOptionPane.ERROR_MESSAGE);
                } else {
                    arrayList.add(user);
                    String resultMessage = "User added to Chat";
                    JOptionPane.showMessageDialog(null, resultMessage,
                            "Start group", JOptionPane.INFORMATION_MESSAGE);
                }
            }

            if (result == 1) {
                for (int i = 0; i < arrayList.size(); i++) {
                    if ( !nameList.contains(arrayList.get(i))){
                        nameList.add(arrayList.get(i));
                    }
                }
                if (nameList.size() < 2) {
                    JOptionPane.showMessageDialog(null, "Must invite at least two users!",
                            "Start group", JOptionPane.WARNING_MESSAGE);
                    result = 0;
                }
            }

            if (result == JOptionPane.CLOSED_OPTION) {
                return null;
            }
        }

        for (int i = 0; i < arrayList.size(); i++) {
            if ( !nameList.contains(arrayList.get(i))){
                nameList.add(arrayList.get(i));
            }
        }
        Collections.sort(nameList);

        return nameList;
    }

    public static void importChat(Socket socket) throws IOException {
        String path = JOptionPane.showInputDialog(null,
                "Enter csv filename (File must at current location)", "Import History",
                JOptionPane.QUESTION_MESSAGE);

        if (path == null) {
            return;
        }

        if (!path.contains("_history") || !path.endsWith(".csv")) {
            JOptionPane.showMessageDialog(null, "Invalid file. You can only import your history!",
                    "Import History", JOptionPane.ERROR_MESSAGE);
            return;
        }

        try {
            BufferedReader reader = new BufferedReader(new InputStreamReader(socket.getInputStream()));
            BufferedReader csvReader = new BufferedReader(new FileReader(path));
            PrintWriter writer = new PrintWriter(socket.getOutputStream());
            String line;
            ArrayList<String> data = new ArrayList<String>();
            while ((line = csvReader.readLine()) != null) {
                data.add(line);
            }
            csvReader.close();

            String name = path.split("_")[0];
            String listnum = path.substring(name.length() + 8, path.indexOf("."));

            if (!name.equals(myUserName) || !path.contains("_history") || !path.endsWith(".csv")) {
                JOptionPane.showMessageDialog(null, "Invalid file. You can only import your history!",
                        "Import History", JOptionPane.ERROR_MESSAGE);
                return;
            }

            writer.write("ImportFile" + "," + listnum + "," + myUserName);
            writer.println();
            writer.flush();
            writer.write(data.get(1));
            writer.println();
            writer.flush();

            String flag = reader.readLine();
            if (flag.equals("false")) {
                JOptionPane.showMessageDialog(null, "Invalid history. You can only import your history!",
                        "Import History", JOptionPane.ERROR_MESSAGE);
                writer.write("");
                writer.println();
                writer.flush();
                return;
            }

            writer.write("LoadHistory");
            writer.println();
            writer.flush();


        } catch (FileNotFoundException e) {
            JOptionPane.showMessageDialog(null, "File not exist!", "Import History",
                    JOptionPane.ERROR_MESSAGE);
            return;
        }


    }



    // All chat methods

    public static void send(String chatNumber, Socket socket) throws IOException {
        PrintWriter writer = new PrintWriter(socket.getOutputStream());
        writer.write("SendMessage" + "," + chatNumber + "," + myUserName + "," + textFieldChat.getText());
        writer.println();
        writer.flush();
    }

    public static void getHistory(String chatNumber, Socket socket) throws IOException {
        BufferedReader reader = new BufferedReader(new InputStreamReader(socket.getInputStream()));
        PrintWriter writer = new PrintWriter(socket.getOutputStream());
        writer.write("GetMessage" + "," + chatNumber + "," + myUserName);
        writer.println();
        writer.flush();
        textAreaChat.setText("");
        String line = reader.readLine();                // first line (count)
        if (!line.equals("null")) {
            int count = Integer.parseInt(line);        // number of history
            for (int i = 0; i < count; i++) {
                line = reader.readLine();
                if (showTime) {
                    textAreaChat.append(line + "\n");
                } else {
                    textAreaChat.append(line.substring(line.indexOf("  ") + 1) + "\n");
                }
            }
        }
    }

    public static void update(String chatNumber, Socket socket) throws IOException, BadLocationException {
        BufferedReader reader = new BufferedReader(new InputStreamReader(socket.getInputStream()));
        PrintWriter writer = new PrintWriter(socket.getOutputStream());
        writer.write("GetMessage" + "," + chatNumber + "," + myUserName);
        writer.println();
        writer.flush();
        String line = reader.readLine();                // first line (count)
        int start;                                      // start of line
        int end;                                        // end of line
        if (line == null) {
            return;
        }
        if (!line.equals("null")) {
            int count = Integer.parseInt(line);        // number of history
            if (textAreaChat.getLineCount() != count + 1) {
                textAreaChat.setText("");
                for (int j = 0; j < count; j++) {
                    line = reader.readLine();
                    if (showTime) {
                        textAreaChat.append(line + "\n");
                    } else {
                        textAreaChat.append(line.substring(line.indexOf("  " ) + 1) + "\n");
                    }
                }
                return;
            }
            for (int i = 0; i < textAreaChat.getLineCount() - 1; i++) {
                start = textAreaChat.getLineStartOffset(i);
                end = textAreaChat.getLineEndOffset(i);
                line = reader.readLine();
                if (showTime) {
                    if (!textAreaChat.getText(start, end - start - 1).equals(line)) {
                        textAreaChat.replaceRange(line + "\n", start, end);
                    }
                } else {
                    if (!textAreaChat.getText(start, end - start - 1).equals(line.substring(line.indexOf("  " ) + 1))) {
                        textAreaChat.replaceRange(line.substring(line.indexOf("  ") + 1) + "\n", start, end);
                    }
                }

            }

        }
    }

    public static void edit(String chatNumber, Socket socket) throws IOException, BadLocationException {
        BufferedReader reader = new BufferedReader(new InputStreamReader(socket.getInputStream()));
        PrintWriter writer = new PrintWriter(socket.getOutputStream());
        if (textAreaChat.getText().equals("")) {
            JOptionPane.showMessageDialog(null, "No history", "Edit Message",
                    JOptionPane.ERROR_MESSAGE);
            return;
        }
        writer.write("EditMessage" + "," + chatNumber + "," + myUserName);
        writer.println();
        writer.flush();
        String fistline = reader.readLine();                    // first line
        int count = Integer.parseInt(fistline);        // number of history
        // re-format message to show
        String[] myMessages = new String[count];                        //  my messages
        String[] messagesToShow = new String[count];                        // list of my messages
        for (int i = 0; i < count; i++) {
            myMessages[i] = reader.readLine();
            messagesToShow[i] = myMessages[i].substring(0, myMessages[i].indexOf(" ") + 9) + "  "
                    + myMessages[i].substring(myMessages[i].indexOf(",") + myUserName.length() + 2);
        }

        // Select
        Collections.reverse(Arrays.asList(messagesToShow));

        String messageSelected = (String) JOptionPane.showInputDialog(null, "Select message to edit",
                "Edit Message", JOptionPane.QUESTION_MESSAGE, null, messagesToShow,
                messagesToShow[0]);                   // message selected
        if (messageSelected == null) {
            writer.write("");
            writer.println();
            writer.flush();
            return;
        }

        int index = myMessages.length - 1 - Arrays.asList(messagesToShow).indexOf(messageSelected);  // index of message
        String newText = "";                                                        // new text entered
        // edit
        do {
            newText = JOptionPane.showInputDialog(null,
                    "Edit: " + messageSelected.substring(messageSelected.indexOf(" ") + 11), "Edit Message",
                    JOptionPane.QUESTION_MESSAGE);                  // after edit
            if (newText == null) {
                writer.write("");
                writer.println();
                writer.flush();
                return;
            }
            if (newText.equals("")) {
                JOptionPane.showMessageDialog(null, "Please enter something or choose Delete", "Edit Message",
                        JOptionPane.ERROR_MESSAGE);
            }
        } while (newText.equals(""));

        String originalMessage = myMessages[index];
        writer.write(originalMessage);
        writer.println();
        writer.flush();
        writer.write(newText + " [edited]");
        writer.println();
        writer.flush();

    }


    public static String getBackgroundColor(Socket socket) throws IOException {

        Scanner in = new Scanner(socket.getInputStream());
        PrintWriter out = new PrintWriter(socket.getOutputStream(), true);

        String hexCode = "#ffffff";
        String line;

        out.println("GET_BACKGROUND_COLOR:" + myUserName);
        //System.out.println(myUserName);

        line = in.nextLine();

        if((line.contains("BACKGROUND_COLOR"))) {
            hexCode = line.substring(line.indexOf(",") + 1);

        }

        return hexCode;
    }

  
    public static String getMessageColor(Socket socket) throws IOException {

        Scanner in = new Scanner(socket.getInputStream());
        PrintWriter out = new PrintWriter(socket.getOutputStream(), true);

        String hexCode = "#000000";
        String line;

        out.println("GET_MESSAGE_COLOR:"  + myUserName);

        line = in.nextLine();

        if((line.contains("MESSAGE_COLOR"))) {
            hexCode = line.substring(line.indexOf(",") + 1);
        }

        return hexCode;
    }



    public static void delete(String chatNumber, Socket socket) throws IOException, BadLocationException {
        BufferedReader reader = new BufferedReader(new InputStreamReader(socket.getInputStream()));
        PrintWriter writer = new PrintWriter(socket.getOutputStream());
        if (textAreaChat.getText().equals("")) {
            JOptionPane.showMessageDialog(null, "No history", "Delete Message",
                    JOptionPane.ERROR_MESSAGE);
            return;
        }
        writer.write("DeleteMessage" + "," + chatNumber + "," + myUserName);
        writer.println();
        writer.flush();

        String fistline = reader.readLine();                    // first line

        int count = Integer.parseInt(fistline);        // number of history
        // re-format message to show
        String[] myMessages = new String[count];                        //  my messages
        String[] messagesToShow = new String[count];                        // list of my messages
        for (int i = 0; i < count; i++) {
            myMessages[i] = reader.readLine();
            messagesToShow[i] = myMessages[i].substring(0, myMessages[i].indexOf(" ") + 9) + "  "
                    + myMessages[i].substring(myMessages[i].indexOf(",") + myUserName.length() + 2);
        }

        // Select
        Collections.reverse(Arrays.asList(messagesToShow));
        String messageSelected = (String) JOptionPane.showInputDialog(null, "Select message to delete",
                "Delete Message", JOptionPane.QUESTION_MESSAGE, null, messagesToShow,
                messagesToShow[0]);                   // message selected
        if (messageSelected == null) {
            writer.write("");
            writer.println();
            writer.flush();
            return;
        }

        int index = myMessages.length - 1 - Arrays.asList(messagesToShow).indexOf(messageSelected);  // index of message

        int yesno = JOptionPane.showConfirmDialog(null, "Delete: " + messageSelected, "Delete Message",
                JOptionPane.YES_NO_OPTION);

        if (yesno == JOptionPane.NO_OPTION) {
            writer.write("");
            writer.println();
            writer.flush();
            return;
        }

        String originalMessage = myMessages[index];
        writer.write(originalMessage);
        writer.println();
        writer.flush();

    }


    public static boolean deleteChat(String chatNumber, Socket socket) throws IOException {

        int yesno = JOptionPane.showConfirmDialog(null, "Are you sure to delete conversation?\n" +
                        "Other user can still see this conversation! ", "Delete Conversation",
                JOptionPane.YES_NO_OPTION);
        if (yesno == JOptionPane.NO_OPTION) {
            return false;
        }
        PrintWriter writer = new PrintWriter(socket.getOutputStream());
        writer.write("DeleteChat" + "," + chatNumber + "," + myUserName);
        writer.println();
        writer.flush();
        return true;
    }

    public static void exportCSV(String chatNumber, Socket socket) throws IOException {

        int yesno = JOptionPane.showConfirmDialog(null, "Exporting chat history? ", "Export History",
                JOptionPane.YES_NO_OPTION);
        if (yesno == JOptionPane.NO_OPTION) {
            return;
        }

        BufferedReader reader = new BufferedReader(new InputStreamReader(socket.getInputStream()));
        PrintWriter writer = new PrintWriter(socket.getOutputStream());

        writer.write("ExportCSV" + "," + chatNumber + "," + myUserName);
        writer.println();
        writer.flush();

        int len = Integer.parseInt(reader.readLine());
        String history;
        PrintWriter pw = new PrintWriter(new File(myUserName + "_history" + chatNumber + ".csv"));
        StringBuilder builder = new StringBuilder();
        builder.append("Time,Participants,Message sender,Message\n");

        String message;
        for (int i = 0; i < len; i++) {
            history = reader.readLine();
            message = history.substring(history.indexOf("!") + 1);
            message = message.substring(message.indexOf("!") + 1);
            message = message.substring(message.indexOf("!") + 1);
            builder.append(history.split("!")[0] + ",");
            builder.append(history.split("!")[1] + ",");
            builder.append(history.split("!")[2] + ",");
            builder.append("\"" + message + "\"" + "\n");
        }
        pw.write(builder.toString());
        pw.close();

        JOptionPane.showMessageDialog(null, "Exporting history to: " + myUserName + "_history" + chatNumber + ".csv",
                "Export History", JOptionPane.INFORMATION_MESSAGE);

    }

    public static void viewMember(String chatNumber, Socket socket) throws IOException {
        BufferedReader reader = new BufferedReader(new InputStreamReader(socket.getInputStream()));
        PrintWriter writer = new PrintWriter(socket.getOutputStream());

        writer.write("ViewMember" + "," + chatNumber + "," + myUserName);
        writer.println();
        writer.flush();
        int count = Integer.parseInt(reader.readLine());
        String members = "";
        for (int i = 0; i < count; i++) {
            members = members + reader.readLine() + "\n";
        }
        JOptionPane.showMessageDialog(null, members, "Members", JOptionPane.INFORMATION_MESSAGE);

    }


    public static void cancelTimer() {
        timerTask.cancel();
        timer.cancel();

    }

    public static void startUpdateTimer(String chatNumber, Socket socket) {
        timer = new Timer();
        TimerTask timerTask = new TimerTask() {
            public void run() {
                try {
                    update(chatNumber, socket);
                } catch (IOException | BadLocationException e) {
                    e.printStackTrace();
                }
            }
        };

        timer.scheduleAtFixedRate(timerTask, 0, 1000);
    }


    public static void main(String[] args) throws IOException {

        Socket socket = new Socket("localhost", 8888);

        SwingUtilities.invokeLater(new Runnable() {
            public void run() {
                try {
                    createLoginGUI();
                    listening(socket);
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
        });
    }

}
