import java.io.*;
import java.nio.file.Paths;
import java.util.ArrayList;
import java.util.Collections;

/** This method include all the methods to modify user's Chat Information
 *
 *  myChatList will return the list of that that the given user is included in
 *
 *  lastIndex gives the biggest index so the function know what index to add next
 *
 *  DeleteChat method will delete the user from the Chat
 */
public class FindChat {
    private String myUserName;
//    private String filename = Paths.get("").toAbsolutePath().toString() + "/listFile.txt";

    public FindChat(String myUserName) {
        this.myUserName = myUserName;
    }

    public ArrayList<String> myChatList() throws IOException {
        ArrayList<String> content = new ArrayList<>();
        ArrayList<String> myChat = new ArrayList();

        try (BufferedReader bfr = new BufferedReader(new FileReader("listFile.txt"))) {
            String line = bfr.readLine();
            while (line != null) {
                content.add(line);
                line = bfr.readLine();
            }
            bfr.close();
        }
        for (int i = 0; i < content.size(); i++) {
            if (content.get(i).split("!")[1].contains(myUserName)) {
                myChat.add(content.get(i));
            }
        }
        return myChat;
    }

    public int lastIndex() {
        ArrayList<String> content = new ArrayList<>();
        int index = 1;

        try (BufferedReader bfr = new BufferedReader(new FileReader("listFile.txt"))) {
            String line = bfr.readLine();
            while (line != null) {
                content.add(line);
                line = bfr.readLine();
            }
            bfr.close();

            if (content.size() == 0) {
                index = 1;
            } else {
                ChatInfo lastLine = new ChatInfo(content.get(content.size()-1));
                index = lastLine.getIndex();
            }
            return index;

        } catch (FileNotFoundException e) {
            e.printStackTrace();
        } catch (IOException e) {
            e.printStackTrace();
        }
        return index;
    }

    public int findIndex(String chatname) {
        ArrayList<String> content = new ArrayList<>();

        try (BufferedReader bfr = new BufferedReader(new FileReader("listFile.txt"))) {
            String line = bfr.readLine();
            while (line != null) {
                content.add(line);
                line = bfr.readLine();
            }
            bfr.close();

            for(int i = 0; i<content.size(); i++) {
                ChatInfo info = new ChatInfo(content.get(i));
                if (chatname.equals(info.getGroupName())){
                    return info.getIndex();
                }
            }
        } catch (FileNotFoundException e) {
            e.printStackTrace();
        } catch (IOException e) {
            e.printStackTrace();
        }
        return 0;
    }

    public void deleteChat(int index, String myUserName) {
        ArrayList<String> content = new ArrayList<>();
        ArrayList<String> newUser = new ArrayList<>();
        String write = "";
        String change = "";

        try (BufferedReader bfr = new BufferedReader(new FileReader("listFile.txt"))) {
            String line = bfr.readLine();
            while (line != null) {
                content.add(line);
                line = bfr.readLine();
            }
            bfr.close();

            for (int i = 0; i < content.size(); i++) {
                ChatInfo chatinfo = new ChatInfo(content.get(i));
                if (chatinfo.getIndex() == index) {
                    newUser = chatinfo.getChatUser();
                    newUser.remove(myUserName);
                    change = change + chatinfo.getIndex();
                    for (int j = 0; j < newUser.size(); j++) {
                        change = change + "," + newUser.get(i);
                    }
                    change = change + "," + chatinfo.getTime();
                    write = write + change + "\n";

                } else {
                    write = write + content.get(i) + "\n";
                }
            }
        } catch (FileNotFoundException e) {
            e.printStackTrace();
        } catch (IOException e) {
            e.printStackTrace();
        }

        try (BufferedWriter bfw = new BufferedWriter(new FileWriter("listFile.txt", false))) {

            bfw.write(write);
            bfw.close();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    /*public static void main(String[] args) throws IOException {
        String myUserName = "Leo";
        ArrayList allUserName = new ArrayList();
        allUserName.add("Bob");
        allUserName.add(myUserName);

        FindChat findchat = new FindChat(myUserName, allUserName);
        System.out.println(findchat.existChat(findchat.myChatList()));
    }*/
}
