import javax.swing.*;
import java.io.*;
import java.net.ServerSocket;
import java.net.Socket;
import java.nio.file.Paths;
import java.nio.file.StandardOpenOption;
import java.sql.Timestamp;
import java.util.*;
import java.util.concurrent.Executors;


public class Server {

//    static final String FILE_PATH = Paths.get("").toAbsolutePath().toString() + "/UserData.txt";
//    static final String UserLocation = Paths.get("").toAbsolutePath().toString();
//    static final String listLocation = UserLocation + "/listFile.txt";
    public static void main(String[] args) throws Exception {
        System.out.println("The server is running...");
        var pool = Executors.newFixedThreadPool(500);
        try (var listener = new ServerSocket(8888)) {
            while (true) {
                pool.execute(new Server.RunServer(listener.accept()));
                System.out.println("Client connected");
            }
        }
    }

    public static class RunServer implements Runnable {
        public Socket socket;
        public Scanner in;
        public PrintWriter out;
        public ArrayList<User> userData = new ArrayList<User>();
        private int index;

        public RunServer(Socket socket) {
            this.socket = socket;
        }


        public void run() {
            try {
                Object gatekeeper = new Object();
                in = new Scanner(socket.getInputStream());
                out = new PrintWriter(socket.getOutputStream(), true);
                String line = null;
                String [] inputData;
                String usernameInput;
                ArrayList<User> userData = null;
                String passwordInput;

                while(true) {
                    try {
                        line = in.nextLine();
                    } catch (Exception e) {
                        System.out.println("Client disconnected");
                        socket.close();
                        break;
                    }
                    //user login authentication
                    if (line.startsWith("USERNAME_PASSWORD_LOGIN")) {
                        inputData = line.split(",");
                        //System.out.println("Inputted Username: " + inputData[1]); //TESTING,works
                        usernameInput = inputData[1];
                        //System.out.println("Inputted Password:" + inputData[2]); //TESTING,works
                        passwordInput = inputData[2];


                        String userNameDatabase;
                        String passWordDatabase;
                        String authentication = "FALSE";

                        //READ FROM FILE AND STORE INTO ARRAYLIST
                        userData = readFile();

                        for (User userDatum : userData) {
                            userNameDatabase = userDatum.getUsername();
                            passWordDatabase = userDatum.getPassword();

                            //System.out.println(userNameDatabase + " " + passWordDatabase); //TESTING

                            //System.out.println(userNameDatabase + " " + passWordDatabase);

                            if (usernameInput.matches(userNameDatabase) && passwordInput.matches(passWordDatabase)) {
                                authentication = "TRUE";
                            }
                        }

                        out.println(authentication);
                        continue;

                    }

                    //User registration
                    if (line.startsWith("USERNAME_PASSWORD_REGISTER")) {


                        inputData = line.split(",");

                        String userNameDatabase;
                        String userRegistration = "TRUE";
                        String newUsername = inputData[1];
                        String newPassword = String.valueOf(inputData[2]);

                        // READ FROM FILE AND STORE INTO ARRAYLIST
                        userData = readFile();

                        for (User userDatum : userData) {
                            userNameDatabase = userDatum.getUsername();

                            if (newUsername.matches(userNameDatabase)) {
                                userRegistration = "FALSE";
                            }

                        }

                        if (userRegistration.equals("TRUE")) {

                            //PRINT TO FILE
                            synchronized (gatekeeper) {
                                writeFile(newUsername, newPassword);
                                userData.add(new User(newUsername, newPassword));
                            }
                        }

                        out.println(userRegistration);
                        continue;
                    }

                    //Delete user profile
                    if (line.startsWith("DELETE_USER_PROFILE")) {
                        String deleteUsername = line.substring(line.indexOf(":") + 1);
                        //System.out.println("Deleting profile:" + line.substring(line.indexOf(":")+ 1));
                        synchronized (gatekeeper) {
                            deleteUser(deleteUsername);
                        }
                        continue;
                    }

                    //password change
                    if (line.startsWith("PASSWORD_CHANGE")) {
                        //System.out.println("New Password:" + line.substring(line.indexOf(",")+1));

                        String[] inputPasswordData = line.split(",");

                        String changePasswordUsername = inputPasswordData[1];
                        String newPassword = inputPasswordData[2];
                        if (changePassword(changePasswordUsername, newPassword)) {
                            out.println("PASSWORD_CHANGE_TRUE");
                        }
                        //System.out.println(newPassword);
                        continue;
                    }

                    if (line.startsWith("MESSAGE")) {

                    }

                    // Chat list
                    if (line.startsWith("StartNewChat")) {
                        String myUserName = line.split(",")[1];
                        String userName = line.split((","))[2];

                        ReadUserName name = new ReadUserName("UserData.txt");
                        userData = name.readUsername();

                        //This will read through the userData file and will create the chat file if the user exist
                        if (userData.contains(userName)) {

                            ArrayList<String> allUserName = new ArrayList<>();
                            allUserName.add(userName);
                            allUserName.add(myUserName);
                            Collections.sort(allUserName);
                            ArrayList<String> myChat = new ArrayList<>();
                            FindChat findChat = new FindChat(myUserName);

                            try {
                                myChat = findChat.myChatList();
                            } catch (IOException e) {
                                e.printStackTrace();
                            }

                            if (existChat(allUserName, myChat).equals("True")) {

                                index = findChat.lastIndex() + 1;
                                String twousers = allUserName.get(0) + "," + allUserName.get(1);
                                synchronized (gatekeeper) {
                                    WriteFile writeFile = new WriteFile(index, "listFile.txt", myUserName, allUserName, twousers);
                                    writeFile.Write();
                                    File file = new File("log" + index + ".txt");
                                    file.createNewFile();
                                }
                                out.println("True");
                                out.flush();
                            } else {
                                out.println("Exist");
                            }
                        } else {
                            out.println("False");
                            out.flush();
                        }
                        continue;
                    }

                    //Start a new group
                    if (line.startsWith("StartNewGroup")) {
                        ArrayList<String> allUserName = new ArrayList<>();

                        String[] allUser = line.split(",");
                        String myUserName = allUser[1];
                        String groupName = allUser[allUser.length - 1];
                        ReadUserName name = new ReadUserName("UserData.txt");
                        userData = name.readUsername();
                        Boolean userExist = true;

                        for (int i = 1; i < allUser.length - 1; i++) {
                            if (userData.contains(allUser[i])) {
                                allUserName.add(allUser[i]);
                            } else {
                                userExist = false;
                                out.println("False," + allUser[i]);
                                break;
                            }
                        }

                        if (userExist) {
                            ArrayList<String> myChat = new ArrayList<>();
                            Collections.sort(allUserName);
                            FindChat findChat = new FindChat(myUserName);
                            try {
                                myChat = findChat.myChatList();
                            } catch (IOException e) {
                                e.printStackTrace();
                            }
                            if (existChat(allUserName, myChat).equals("True")) {
                                index = findChat.lastIndex() + 1;
                                synchronized (gatekeeper) {
                                    WriteFile writeFile = new WriteFile(index, "listFile.txt", myUserName, allUserName, groupName);
                                    writeFile.Write();
                                    File file = new File("log" + index + ".txt");
                                    file.createNewFile();
                                }
                                out.println("True");
                                out.flush();
                            } else {
                                out.println("Exist");
                            }
                        }
                        continue;
                    }

                    if (line.startsWith("START_MESSAGE")) {
                        String myname = in.nextLine();
                        FindChat fIndex = new FindChat(myname);
                        String select = in.nextLine();
                        int chatlistnumber = 0;
                        String groupName = "";
                        try {
                            ArrayList<String> myChat = fIndex.myChatList();
                            for (int i = 0; i < myChat.size(); i++) {
                                ChatInfo chatinfo = new ChatInfo(myChat.get(i));
                                if (chatinfo.getGroupName().contains(myname + "," + select) ||
                                        chatinfo.getGroupName().contains(select + "," + myname)) {
                                    chatlistnumber = chatinfo.getIndex();
                                    groupName = chatinfo.getGroupName();
                                }
                            }
                            if (chatlistnumber == 0) {
                                for (int i = 0; i < myChat.size(); i++) {
                                    ChatInfo chatinfo = new ChatInfo(myChat.get(i));
                                    if (chatinfo.getGroupName().equals(select)) {
                                        chatlistnumber = chatinfo.getIndex();
                                        groupName = chatinfo.getGroupName();
                                    }
                                }
                            }
                        } catch (IOException e) {
                            e.printStackTrace();
                        }

                        out.println(String.valueOf(chatlistnumber));
                        out.flush();
                        out.println(groupName);
                        out.flush();
                        continue;
                    }

                    if (line.startsWith("SortList")) {
                        String myUserName = line.split(",")[1];

                        ArrayList<String> content = new ArrayList<>();
                        ArrayList<String> chats = new ArrayList<>();

                        try (BufferedReader bfr = new BufferedReader(new FileReader("listFile.txt"))) {
                            String linelist = bfr.readLine();
                            while (linelist != null) {
                                content.add(linelist);
                                linelist = bfr.readLine();
                            }
                            bfr.close();
                        }
                        for (int i = 0; i < content.size(); i++) {
                            if (content.get(i).split("!")[1].contains(myUserName)) {
                                chats.add(content.get(i));
                            }
                        }

                        List<String> times = new ArrayList<>();
                        List<String> chatNames = new ArrayList<>();

                        for (int i = 0; i < chats.size(); i++) {
                            line = chats.get(i);
                            ChatInfo info = new ChatInfo(line);
                            String chat = info.getGroupName();
                            String time = info.getTime();
                            chatNames.add(chat);
                            times.add(time);
                        }

                        for (int i = 1; i < chats.size(); i++) {
                            for (int j = 0; j < chatNames.size() - i; j++) {
                                String[] time = times.get(j).split(" ");
                                String[] dates1 = time[0].split("-");
                                String[] time1 = time[1].split(":");

                                String[] time2 = times.get(j + 1).split(" ");
                                String[] dates2 = time2[0].split("-");
                                String[] times2 = time2[1].split(":");

                                //Check if any of the dates are equal
                                int day1 = Integer.parseInt(dates1[2]);
                                int day2 = Integer.parseInt(dates2[2]);
                                int month1 = Integer.parseInt(dates1[1]);
                                int month2 = Integer.parseInt(dates2[1]);
                                int year1 = Integer.parseInt(dates1[0]);
                                int year2 = Integer.parseInt(dates2[0]);
                                double hour1 = Double.parseDouble(time1[0]);
                                double hour2 = Double.parseDouble(times2[0]);
                                double min1 = Double.parseDouble(time1[1]);
                                double min2 = Double.parseDouble(times2[1]);
                                double sec1 = Double.parseDouble(time1[2]);
                                double sec2 = Double.parseDouble(times2[2]);
                                double realTime1 = (hour1) + (min1 / 60) + (sec1 / 3600);
                                double realTime2 = (hour2) + (min2 / 60) + (sec2 / 3600);

                                boolean year = (year1 == year2);
                                boolean month = (month1 == month2);
                                boolean day = (day1 == day2);
                                if (year2 > year1 || (year && month2 > month1) || (year && month && day2 > day1)
                                        || (year && month && day && realTime2 > realTime1)) {
                                    String temp = times.get(j);
                                    String temp2 = times.get(j + 1);
                                    String name1 = chatNames.get(j);
                                    String name2 = chatNames.get(j + 1);
                                    chatNames.set(j, name2);
                                    chatNames.set(j + 1, name1);
                                    times.set(j, temp2);
                                    times.set(j + 1, temp);
                                }
                            }
                        }

                        out.println(chats.size());
                        out.flush();

                        for (int i = 0; i < chats.size(); i++) {
                            String name = chatNames.get(i);
                            out.println(name);
                            out.flush();
                        }
                        continue;
                    }

                    if (line.startsWith("ImportFile")) {
                        String listnum = line.split(",")[1];
                        String name = line.split(",")[2];
                        line = in.nextLine();
                        String time = line.split(",")[0];
                        try {
                            BufferedReader readerList = new BufferedReader(new FileReader("listFile.txt"));
                            BufferedReader readerChat = new BufferedReader(new FileReader("log" + listnum + ".txt"));

                            ArrayList<String> data = new ArrayList<String>();
                            String flag = "false";
                            line = readerList.readLine();

                            while (line != null) {
                                data.add(line);
                                if (line.split("!")[0].equals(listnum)) {
                                    if (line.split("!")[1].contains(name)) {
                                        if (readerChat.readLine().split(",")[0].equals(time)) {
                                            flag = "true";
                                        }
                                    }
                                }
                                line = readerList.readLine();
                            }

                            out.println(flag);
                            out.flush();

                            line = in.nextLine();
                            if (line.equals("")) {
                                continue;
                            }

                            synchronized (gatekeeper) {
                                BufferedWriter writer = new BufferedWriter(new FileWriter("listFile.txt", false));

                                for (int i = 0; i < data.size(); i++) {
                                    line = data.get(i);
                                    if (line.split("!")[0].equals(listnum)) {
                                        if (line.split("!")[1].contains("'" + name + "'")) {
                                            line = line.replace("'" + name + "'", name);
                                        }
                                    }
                                    writer.write(line + "\n");
                                }
                                readerChat.close();
                                readerList.close();
                                writer.close();
                            }
                            continue;
                        } catch (FileNotFoundException e) {
                            out.println("false");
                            out.flush();
                        }
                    }

                    if (line.startsWith("Administrator")) {
                        BufferedReader readerList = new BufferedReader(new FileReader("listFile.txt"));

                        line = readerList.readLine();
                        ArrayList<String> chats = new ArrayList<String >();
                        while (line != null) {
                            chats.add(line.split("!")[0] + ": " + line.split("!")[3]);
                            line = readerList.readLine();
                        }

                        out.println(String.valueOf(chats.size()));
                        out.flush();

                        for (int i = 0; i < chats.size(); i++) {
                            out.println(chats.get(i));
                            out.flush();
                        }
                        line = "";
                        readerList.close();
                        continue;
                    }

                    if (line.startsWith("BanUser")) {
                        BufferedReader reader = new BufferedReader(new FileReader("UserData.txt"));
                        ArrayList<String> allusers = new ArrayList<String>();
                        line = reader.readLine();
                        while (line != null) {
                            if (!line.split(",")[0].equals("DELETED")) {
                                allusers.add(line.split(",")[0]);
                            }
                            line = reader.readLine();
                        }
                        allusers.remove("Admin");
                        out.println(String.valueOf(allusers.size()));
                        out.flush();

                        for (int i = 0; i < allusers.size(); i++) {
                            out.println(allusers.get(i));
                            out.flush();
                        }

                        String select = in.nextLine();
                        if (select.equals("")) {
                            continue;
                        }

                        deleteUser(select);

                        reader.close();
                        continue;
                    }

                    // chat
                    if (line.startsWith("GetMessage")) {
                        line = line.substring(line.indexOf(",") + 1);
                        String chatlist = line.substring(0, line.indexOf(","));     // chat list
                        String name = line.substring(line.indexOf(",") + 1);       // name
                        ArrayList<Message> history = loadFile(chatlist);
                        synchronized (gatekeeper) {
                            if (history == null) {
                                out.write("null");
                                out.println();
                                out.flush();
                                break;
                            }
                            out.write(String.valueOf(history.size()));
                            out.println();
                            out.flush();
                            for (Message message : history) {
                                out.write(message.getTime().substring(0, message.getTime().indexOf(".")) +
                                        "  " + message.getName() + ": " + message.getSentence());
                                out.println();
                                out.flush();
                            }
                        }
                        continue;
                    }

                    if (line.startsWith("SendMessage")) {

                        line = line.substring(line.indexOf(",") + 1);
                        String chatlist = line.substring(0, line.indexOf(","));     // chat list
                        line = line.substring(line.indexOf(",") + 1);
                        String name = line.substring(0, line.indexOf(","));   // name
                        String sentence = line.substring(line.indexOf(",") + 1);    // one message

                        Date date = new Date();
                        String time = String.valueOf(new Timestamp(date.getTime()));

                        Message message = new Message(chatlist, name, sentence, time);

                        synchronized (gatekeeper) {
                            logFile(message);
                        }
                        continue;
                    }

                    if (line.startsWith("EditMessage")) {

                        line = line.substring(line.indexOf(",") + 1);
                        String chatlist = line.substring(0, line.indexOf(","));     // chat list
                        String name = line.substring(line.indexOf(",") + 1);       // name
                        ArrayList<String> myMessages = getMyMessages(chatlist, name);
                        out.write(String.valueOf(myMessages.size()));
                        out.println();
                        out.flush();
                        for (String m : myMessages) {
                            out.write(m);
                            out.println();
                            out.flush();
                        }

                        String originalMessage = in.nextLine();
                        if (originalMessage.equals("")) {
                            continue;
                        }
                        String newMessage = in.nextLine();      // new message
                        ArrayList<Message> messages = loadFile(chatlist);

                        synchronized (gatekeeper) {
                            editMessage(originalMessage, newMessage, chatlist, messages);      // line to change
                        }
                        continue;
                    }

                    if (line.startsWith("DeleteMessage")) {

                        line = line.substring(line.indexOf(",") + 1);
                        String chatlist = line.substring(0, line.indexOf(","));     // chat list
                        String name = line.substring(line.indexOf(",") + 1);       // name

                        ArrayList<String> myMessages3 = getMyMessages(chatlist, name);

                        out.write(String.valueOf(myMessages3.size()));
                        out.println();
                        out.flush();
                        for (String m : myMessages3) {
                            out.write(m);
                            out.println();
                            out.flush();
                        }

                        String deleteMessage = in.nextLine();
                        if (deleteMessage.equals("")) {
                            continue;
                        }
                        synchronized (gatekeeper) {
                            deleteMessage(deleteMessage, name, chatlist, loadFile(chatlist));      // line to change
                        }
                        continue;
                    }

                    if (line.startsWith("DeleteChat")) {
                        line = line.substring(line.indexOf(",") + 1);
                        String chatlist = line.substring(0, line.indexOf(","));     // chat list
                        String name = line.substring(line.indexOf(",") + 1);       // name
                        String userFile = "listFile.txt";

                        ArrayList<String> list = new ArrayList<String>();

                        try {
                            File f = new File(userFile);
                            FileReader fr = new FileReader(f);
                            BufferedReader bfr = new BufferedReader(fr);

                            line = bfr.readLine();

                            do {
                                list.add(line);
                            } while ((line = bfr.readLine()) != null);
                            synchronized (gatekeeper) {
                                BufferedWriter writer = new BufferedWriter(new FileWriter(f, false));

                                for (int i = 0; i < list.size(); i++) {
                                    line = list.get(i);
                                    if (line.split("!")[0].equals(chatlist)) {
                                        String second = line.substring(line.indexOf("!") + 1);
                                        String third = second.substring(second.indexOf("!") + 1);
                                        second = second.substring(0, second.indexOf("!"));
                                        second = second.replace(name, "'" + name + "'");
                                        line = chatlist + "!" + second + "!" + third;
                                    }
                                    writer.write(line + "\n");

                                }
                            writer.close();
                            }
                        } catch (FileNotFoundException e) {
                            e.printStackTrace();
                        } catch (IOException e) {
                            e.printStackTrace();
                        }
                        continue;

                    }

                    if (line.startsWith("ExportCSV")) {
                        line = line.substring(line.indexOf(",") + 1);
                        String chatlist = line.substring(0, line.indexOf(","));     // chat list
                        String name = line.substring(line.indexOf(",") + 1);       // name

                        ArrayList<String> history = new ArrayList<String>();
                        BufferedReader readerList = new BufferedReader(new FileReader("listFile.txt"));
                        String allUser = null;
                        line = readerList.readLine();
                        while (line != null) {
                            if (line.split("!")[0].equals(chatlist)) {
                                allUser = line.split("!")[1];
                            }
                            line = readerList.readLine();
                        }

                        String users = "";
                        for (int i = 0; i < allUser.split(",").length; i++) {
                            if (!allUser.split(",")[i].equals("")) {
                                if (allUser.split(",")[i].contains("'")) {
                                    users = users + " " + allUser.split(",")[i] + "(deleted)";
                                    users = users.replaceAll("'", "");
                                } else {
                                    users = users + " " + allUser.split(",")[i];
                                }
                            }
                        }
                        users = users.substring(1);
                        readerList.close();

                        BufferedReader reader = new BufferedReader(new FileReader("log" + chatlist + ".txt"));
                        line = reader.readLine();
                        String time;
                        String sendUser;
                        String message;

                        while (line != null) {
                            time = line.split(",")[0];
                            sendUser = line.split(",")[1];
                            line = line.substring(line.indexOf(",") + 1);
                            message = line.substring(line.indexOf(",") + 1);

                            history.add(time + "!" + users + "!" + sendUser + "!" + message);
                            line = reader.readLine();
                        }
                        line = "";

                        out.println(String.valueOf(history.size()));
                        out.flush();

                        for (int i = 0; i < history.size(); i++) {
                            out.println(history.get(i));
                            out.flush();
                        }

                        reader.close();
                        continue;
                    }

                    if (line.startsWith("ViewMember")) {
                        line = line.substring(line.indexOf(",") + 1);
                        String chatlist = line.substring(0, line.indexOf(","));     // chat list
                        String name = line.substring(line.indexOf(",") + 1);       // name

                        BufferedReader readerList = new BufferedReader(new FileReader("listFile.txt"));
                        String allUser = null;
                        line = readerList.readLine();
                        while (line != null) {
                            if (line.split("!")[0].equals(chatlist)) {
                                allUser = line.split("!")[1];
                            }
                            line = readerList.readLine();
                        }
                        readerList.close();
                        String members = "";
                        for (int i = 0; i < allUser.split(",").length; i++) {
                            if (!allUser.split(",")[i].equals("")) {
                                if (allUser.split(",")[i].contains("'")) {
                                    members = members + allUser.split(",")[i] + " (deleted)" + "\n";
                                    members = members.replaceAll("'", "");
                                } else {
                                    members = members + allUser.split(",")[i] + "\n";
                                }
                            }
                        }

                        out.println(String.valueOf(members.split("\n").length));
                        out.flush();
                        for (int i = 0; i < members.split("\n").length; i++) {
                            out.println(members.split("\n")[i]);
                            out.flush();
                        }
                        continue;
                    }


                    if(line.startsWith("SETTINGS_BACKGROUND_COLOR")){

                        String trimmedLine = line.substring(line.indexOf(":")+1);
                        String[] userMessageColor = trimmedLine.split(",");

                        String userName = userMessageColor[0];
                        String backgroundColor = userMessageColor[1];


                        //Call method that changes message color in file
                        if(changeBackgroundColor(userName,backgroundColor)){
                            out.println("SETTINGS_BACKGROUND_COLOR_TRUE");
                        }

                    }
                    //Set message color to user data
                    if(line.startsWith("SETTINGS_MESSAGE_COLOR")){

                        String trimmedLine = line.substring(line.indexOf(":")+1);
                        String[] userMessageColor = trimmedLine.split(",");

                        String userName = userMessageColor[0];
                        String messageColor = userMessageColor[1];

                        //Call method that changes message color in file
                        if(changeMessageColor(userName,messageColor)){
                            out.println("SETTINGS_MESSAGE_COLOR_TRUE");
                        }

                    }

                    if(line.startsWith("GET_BACKGROUND_COLOR:")){

                        ArrayList<User> colorData;
                        String backgroundColor = "#ffffff";

                        String trimmedLine = line.substring(line.indexOf(":")+1);

                        String userName = trimmedLine;

                        colorData = readFile();

                        for (User colorDatum : colorData) {

                            if (colorDatum.getUsername().equals(userName)) {
                                backgroundColor = colorDatum.getBackgroundColor();
                            }
                        }

                        out.println("BACKGROUND_COLOR" + "," + backgroundColor);
                    }

                    if(line.startsWith("GET_MESSAGE_COLOR:")){

                        ArrayList<User> colorData = new ArrayList<User>();
                        String messageColor = "#000000";

                        String trimmedLine = line.substring(line.indexOf(":")+1);
                        String[] userMessageColor = trimmedLine.split(",");

                        String userName = userMessageColor[0];

                        colorData = readFile();

                        for (User colorDatum : colorData) {
                            if (colorDatum.getUsername().equals(userName)) {
                                messageColor = colorDatum.getMessageColor();
                            }
                        }

                        out.println("MESSAGE_COLOR" + "," + messageColor);

                    }


                }
            } catch (FileNotFoundException e) {
                e.printStackTrace();
            } catch (IOException e) {
                e.printStackTrace();
            } finally {
                try {
                    socket.close();
                } catch(IOException e) {
                }
            }
        }

    }


    //write to file
    public static void writeFile(String username , String password){

        File g = new File("UserData.txt");
        String backgroundColor = "#ffffff";
        String messageColor = "#000000";

        try {

            FileOutputStream fos = new FileOutputStream(g, true);
            PrintWriter pw = new PrintWriter(fos);


            pw.append(username).append(",").append(password).append(",").append(backgroundColor).append(",").append(messageColor).append("\n");
            //pw.println(username + "," + password);
            pw.flush();
            pw.close();


        }catch(IOException e){
            e.printStackTrace();
        }


    }

    //read from file
    public static ArrayList<User> readFile(){

        ArrayList<User> data = new ArrayList<User>();

        try{
            File f = new File("UserData.txt");
            FileReader fr = new FileReader(f);
            BufferedReader bfr = new BufferedReader(fr);

            String userName;
            String userPassword;
            String backgroundColor;
            String messageColor;
            String[] inputData;

            String line = bfr.readLine();
            //System.out.println(line);

            do{

                inputData = line.split(",");

                userName = inputData[0];
                //System.out.println(userName);
                userPassword = inputData[1];
                //System.out.println(userPassword);
                backgroundColor = inputData[2];
//                System.out.println("BackgroundCOLOR READFILE:"+ backgroundColor);
                messageColor = inputData[3];
                //System.out.println(messageColor);


                //System.out.println("Reading from file:" + userName + " " + userPassword); //TEST

                data.add(new User(userName,userPassword,backgroundColor,messageColor));

            }while ((line = bfr.readLine())!=null);

        } catch (FileNotFoundException e) {
            e.printStackTrace();
        } catch (IOException e) {
            e.printStackTrace();
        }

        return data;

    }

    //delete user from datafile
    public static boolean changePassword(String removeID, String newPassword) throws IOException {

        File f = new File("UserData.txt");
        FileReader fr = new FileReader(f);
        BufferedReader br = new BufferedReader(fr);


        File temp = new File("temp.txt");
        FileOutputStream fos = new FileOutputStream(temp, false);
        PrintWriter bw = new PrintWriter(fos);

        String currentLine;
        while((currentLine = br.readLine()) != null){
            String trimmedLine = currentLine.substring(0,currentLine.indexOf(","));
            if(trimmedLine.equals(removeID)){
                currentLine = removeID + "," + newPassword;
            }
            bw.println(currentLine.trim());
        }
        bw.close();
        br.close();
        boolean delete = f.delete();
        boolean b = temp.renameTo(f);
        return true;

    }

    //Delete user
    public static void deleteUser(String removeID) throws IOException {

        File f = new File("UserData.txt");
        FileReader fr = new FileReader(f);
        BufferedReader br = new BufferedReader(fr);


        File temp = new File("temp.txt");
        FileOutputStream fos = new FileOutputStream(temp, false);
        PrintWriter bw = new PrintWriter(fos);

        String currentLine;
        while((currentLine = br.readLine()) != null){
            String trimmedLine = currentLine.substring(0,currentLine.indexOf(","));
            if(trimmedLine.equals(removeID)){
                currentLine = "DELETED,USER,DELETED,USER";
            }
            bw.println(currentLine.trim());
        }
        bw.close();
        br.close();
        boolean delete = f.delete();
        boolean b = temp.renameTo(f);


    }

    public ArrayList<String> getUsernames(){

        ArrayList<String> userNames = new ArrayList<String>();

        try{
            File f = new File("UserData.txt");
            FileReader fr = new FileReader(f);
            BufferedReader bfr = new BufferedReader(fr);

            String userName;

            String line = bfr.readLine();

            do{

                userName = line.substring(0, line.indexOf(","));


                //System.out.println("Reading from file:" + userName + " " + userPassword); //TEST

                if(!userName.equals("DELETED")){
                    userNames.add(userName);
                }



            }while ((line = bfr.readLine())!=null);

        } catch (FileNotFoundException e) {
            e.printStackTrace();
        } catch (IOException e) {
            e.printStackTrace();
        }

        return userNames;

    }

    //change background color
    //todo: New code
    public static boolean changeBackgroundColor(String userID, String backgroundColor) throws IOException {

        File f = new File("UserData.txt");
        FileReader fr = new FileReader(f);
        BufferedReader br = new BufferedReader(fr);


        File temp = new File("temp.txt");
        FileOutputStream fos = new FileOutputStream(temp, false);
        PrintWriter bw = new PrintWriter(fos);
        String [] appendLine;

        String currentLine;
        while((currentLine = br.readLine()) != null){
            String userName = currentLine.substring(0,currentLine.indexOf(","));

            //System.out.println(userID + " " + userName);

            if(userName.equals(userID)){
                appendLine = currentLine.split(",");
                currentLine = appendLine[0] + "," + appendLine[1] + "," +  backgroundColor + "," + appendLine[3];
            }
            bw.println(currentLine.trim());
        }
        bw.close();
        br.close();
        boolean delete = f.delete();
        boolean b = temp.renameTo(f);
        return true;

    }

    //change message color
    public static boolean changeMessageColor(String userID, String messageColor) throws IOException {

        File f = new File("UserData.txt");
        FileReader fr = new FileReader(f);
        BufferedReader br = new BufferedReader(fr);


        File temp = new File("temp.txt");
        FileOutputStream fos = new FileOutputStream(temp, false);
        PrintWriter bw = new PrintWriter(fos);
        String [] appendLine;

        String currentLine;
        while((currentLine = br.readLine()) != null){
            String userName = currentLine.substring(0,currentLine.indexOf(","));


            if(userName.equals(userID)){
                appendLine = currentLine.split(",");
                currentLine = appendLine[0] + "," + appendLine[1] + "," +  appendLine[2] + "," + messageColor;
            }
            bw.println(currentLine.trim());
        }
        bw.close();
        br.close();
        boolean delete = f.delete();
        boolean b = temp.renameTo(f);
        return true;

    }

    public static String existChat(ArrayList allUserName, ArrayList<String> myChat){
        String exist = "True";

        for (int i = 0; i < myChat.size(); i++) {

            ChatInfo chatinfo = new ChatInfo(myChat.get(i));
            if (chatinfo.getChatUser().equals(allUserName)) {
                exist = "False";
            }
        }
        return exist;
    }



    public static void logFile(Message message) {
        try {
            String filename =  "log" + message.getChatlist() + ".txt";             // file name of save file
            BufferedWriter writer = new BufferedWriter(new FileWriter(filename, true));
            writer.write(message.toString() + "\n");
            writer.close();

        } catch (Exception e) {

        }
    }

    public static ArrayList<Message> loadFile(String chatlist) throws IOException {
        ArrayList<Message> message = new ArrayList<Message>();
        try {
            BufferedReader reader = new BufferedReader(new FileReader("log" + chatlist + ".txt"));
            String line = reader.readLine();
            while (line != null) {
                String time = line.substring(0, line.indexOf(","));         // time
                line = line.substring(line.indexOf(",") + 1);
                String name = line.substring(0, line.indexOf(","));         // name
                String sentence = line.substring(line.indexOf(",") + 1);    // sentence
                message.add(new Message(chatlist, name, sentence, time));
                line = reader.readLine();
            }
            reader.close();
        } catch (FileNotFoundException e) {
            BufferedWriter writer = new BufferedWriter(new FileWriter("log" + chatlist + ".txt", true));
            writer.write("");
            loadFile(chatlist);
        } catch (IOException ioException) {
            ioException.printStackTrace();
        }

        return message;
    }

    public static ArrayList<String> getMyMessages(String chatlist, String name) throws IOException {
        ArrayList<String> myMessages = new ArrayList<String>();                   // a list of my messages
        try {
            BufferedReader reader = new BufferedReader(new FileReader("log" + chatlist + ".txt"));
            String line = reader.readLine();
            while (line != null) {
                if (line.split(",")[1].equals(name)) {
                    if (!line.split(",")[2].equals("[Withdrawal a message]")) {
                        myMessages.add(line);
                    }
                }
                line = reader.readLine();
            }
            reader.close();
        } catch (FileNotFoundException e) {
            BufferedWriter writer = new BufferedWriter(new FileWriter("log" + chatlist + ".txt", true));
            writer.write("");
            getMyMessages(chatlist, name);
        }
        return myMessages;
    }

    public static void editMessage(String originalMessage, String newMessage,
                                   String chatlist, ArrayList<Message> messages) throws IOException {
        BufferedWriter writer = new BufferedWriter(new FileWriter("log" + chatlist + ".txt", false));
        for (Message m : messages) {
            if (m.toString().equals(originalMessage)) {
                m.setSentence(newMessage);
            }
            writer.write(m.toString() + "\n");

        }
        writer.close();
    }

    public static void deleteMessage(String deleteMessage, String name, String chatlist,
                                     ArrayList<Message> messages) throws IOException {
        BufferedWriter writer = new BufferedWriter(new FileWriter("log" + chatlist + ".txt", false));
        for (Message m : messages) {
            if (m.toString().equals(deleteMessage)) {
                m.setSentence("[Withdrawal a message]");
            }
            writer.write(m.toString() + "\n");
        }
        writer.close();
    }


}
